/****(c) 2020. A. Gerbessiotis. See ../KAagcopy.txt ****/
/*******************************************************/
#include "aggssrt.h"
 /* QuickSort Recursive using while loops */
 /* g6qkrw3 : MIDDLE ;med3 possible ; inline InsSort ;  */
 /* g7qkrw3 : MIDDLE ;med3 possible ; one InsSort at end*/

/************************
 * Note : code differs from CLR Hoare code in the following respect
 * say input 10 9 8 7 5 and splitter is middle key 8
 * at termination we have say l=1 r=5 in the beginning
 *           6 7  8 9 10
 *             r    l
 * left partition is 6 7 and right partion is ? 9 10 or  8 9 10?
 * if all keys are equal
 *           8 8  8  8 8
 *             r     l   at termination
 *  In the g67.c code which is similar (but original and possibly primitive)
 *  left set is L ... r of size r-L+1   base left set keys[L*size]
 *  righ set is l ... R of size R-l+1 correctly identifies keys[l*size]
 * if ? and also by extension in ? we used(pending before potential changes)
 * left set is size r+1 and right set of size n-l : does not make much sense.
 */

char *
med3(char *a, char *b, char *c,int(*compare)(const void*,const void*))
;


void 
x63(void *akeys, int   n,int size,int (*compare)(const void*,const void*))
{
register int  M,c,l,r;
register char *SRC,*DES;
register char *keys=(char*) akeys, *split;
register char *pl,*pr,*pm /* , *pt */;
static char X[64];

 if (n <= 1) return ;
 l=0; r=n-1; split=X; pl=keys+l*size; pr=keys+r*size;

#if SPLITTER == MIDDLE_KEY
 MEMCPY(split,&keys[((l+r)>>1)*size],size);
/*
if (n>8) {
 pl=keys+l*size; pr=keys+r*size; pm=keys+ ((l+r)>>1)*size;
 pt=med3(pl,pm,pr,compare);
 MEMCPY(split,pt,size);
} else {
 MEMCPY(split,&keys[((l+r)>>1)*size],size);
}
*/
#elif SPLITTER == FIRST_KEY
 MEMCPY(split,&keys[l*size],size);
#elif SPLITTER == RANDOM_KEY
 MEMCPY(split,&keys[(l+GRANDOM((r-l+1)))*size],size);
#endif






  while (l <= r) {
      while (compare(pl,split)<0) {++l;pl +=size;}
      while (compare(split,pr)<0) {--r;pr -=size;}
      if (l <= r) {
         /* MEMCPY(tmp,pl,size); MEMCPY(pl,pr,size); MEMCPY(pr,tmp,size);
            ++l;--r;pl += size; pr -= size; */
         M=size;
         do  { c=*pl; *pl++=*pr;*pr++=c;} while (--M);
         ++l;--r;pr-=size;pr-=size;
      }
  }
  
  if (r > 0) {
      if ((r+1)<SGQUI  ) {
                   pl=keys;
                   for(pr=pl+size;pr< pl+(r+1)*size;pr+=size){
		     MEMCPY(split,pr,size);
                     for(pm=pr;pm>pl && (compare(pm-size,split)>0); pm-=size){
                       MEMCPY((pm),(pm-size),size);
                     }
                     MEMCPY((pm),split,size);
                   }
      }
      else x63(keys,r+1,size,compare);
  }
  if (l < n) {
      if ((n - l)<SGQUI  ) {
                   pl=keys+l*size;
                   for(pr=pl+size;pr< pl+(n-l)*size;pr+=size){
		     MEMCPY(split,pr,size);
                     for(pm=pr;pm>pl && (compare(pm-size,split)>0); pm-=size){
                       MEMCPY((pm),(pm-size),size);
                     }
                     MEMCPY((pm),split,size);
                   }
      }
      else x63(keys+l*size,n-l,size,compare);
  }
}
           
void g6qkrw3 (void *keys,int n,int size,int(*compare)(const void*,const void *))
{
  if (n <= 1) return ;
#if SPLITTER == RANDOM_KEY
 GSRANDOM();
#endif
  x63(keys,n,size,compare);
}

void 
x73(void *akeys, int   n,int size,int (*compare)(const void*,const void*))
{
register int  M,c,l,r;
register char *SRC,*DES;
register char *keys=(char*) akeys, *split;
register char *pl,*pr /* ,*pm  , *pt */;
static char X[64];

 if (n <= 1) return ;
 l=0; r=n-1; split=X; pl=keys+l*size; pr=keys+r*size;

#if SPLITTER == MIDDLE_KEY
 MEMCPY(split,&keys[((l+r)>>1)*size],size);
/*
if (n>8) {
 pl=keys+l*size; pr=keys+r*size; pm=keys+ ((l+r)>>1)*size;
 pt=med3(pl,pm,pr,compare);
 MEMCPY(split,pt,size);
} else {
 MEMCPY(split,&keys[((l+r)>>1)*size],size);
}
*/
#elif SPLITTER == FIRST_KEY
 MEMCPY(split,&keys[l*size],size);
#elif SPLITTER == RANDOM_KEY
 MEMCPY(split,&keys[(l+GRANDOM((r-l+1)))*size],size);
#endif






  while (l <= r) {
      while (compare(pl,split)<0) {++l;pl +=size;}
      while (compare(split,pr)<0) {--r;pr -=size;}
      if (l <= r) {
         /* MEMCPY(tmp,pl,size); MEMCPY(pl,pr,size); MEMCPY(pr,tmp,size);
            ++l;--r;pl += size; pr -= size; */
         M=size;
         do  { c=*pl; *pl++=*pr;*pr++=c;} while (--M);
         ++l;--r;pr-=size;pr-=size;
      }
  }
  
  if (r > 0) {
      if ((r+1)<SGQUI  ) {
/*
                   pl=keys;
                   for(pr=pl+size;pr< pl+(r+1)*size;pr+=size){
		     MEMCPY(split,pr,size);
                     for(pm=pr;pm>pl && (compare(pm-size,split)>0); pm-=size){
                       MEMCPY((pm),(pm-size),size);
                     }
                     MEMCPY((pm),split,size);
                   }
*/
      }
      else x73(keys,r+1,size,compare);
  }
  if (l < n) {
      if ((n - l)<SGQUI  ) {
/*
                   pl=keys+l*size;
                   for(pr=pl+size;pr< pl+(n-l)*size;pr+=size){
		     MEMCPY(split,pr,size);
                     for(pm=pr;pm>pl && (compare(pm-size,split)>0); pm-=size){
                       MEMCPY((pm),(pm-size),size);
                     }
                     MEMCPY((pm),split,size);
                   }
*/
      }
      else x73(keys+l*size,n-l,size,compare);
  }
}

void g7qkrw3 (void *keys,int n,int size,int(*compare)(const void*,const void *))
{
  if (n <= 1) return ;
#if SPLITTER == RANDOM_KEY
 GSRANDOM();
#endif
  x63  (keys,n,size,compare);
  BGQUI(keys,n,size,compare);
}
