/****(c) 2020. A. Gerbessiotis. See ../KAagcopy.txt ****/
/*******************************************************/
#include "aggssrt.h"
 /* Iterative MergeSort with baseline InsertionSort              */
 /* Optimized versions in q3mrgiu  with inline sort in q3mrgio   */
 /* InsertionSort calls use one for loop - no if                 */
void g4mrgiu(void *akeys,int n,int size,int(*compare)(const void*,const void*))
{  
 register int M;
 register char *DES, *SRC;
 register char *keys=(char*) akeys;
 register char *temp, *s,*d,*t;
 register int  i,j,k,ii,jj,a,b;

 if (n<2) return;   /* <=1 vs < 2 */
 temp = (char *) malloc(n*size*sizeof(char));

 for(i=0; i < n ; i+=SGMRG  ) {
      BGMRG(keys + i*size, MIN(SGMRG  , (n-i)), size, compare);
 }






 s=keys; d=temp;
 for(a=SGMRG; a<n; a=(a+a)) {  /* (a<<1) or (a+a) */
    for(b=0; b<n; b+=(a+a)) {
       ii=MIN(b+a,n);             jj=MIN(b+(a+a), n); 
       i=b;                        j=ii; k=i;
        while ((i<ii)&&(j<jj)) {
           if (compare(s+j*size,s+i*size)< 0) {
              MEMCPY(d+k*size, s+j*size, size);
              ++j; ++k;
           }
           else {
              MEMCPY(d+k*size, s+i*size, size);
              ++i;++k;
           }
         }
         if (i< ii) MEMCPY(d+k*size, s+i*size, (ii-i)*size);  
         if (j< jj) MEMCPY(d+k*size, s+j*size, (jj-j)*size);
      }
      t=s; s=d; d=t;
 }

  if (s!=keys) MEMCPY(keys,s,n*size);
  free((void *)temp);
}


void g4mrgiv (void *akeys,int n,int size,int (*compare)(const void*,const void*) )
{   
 register int M;
 register char *DES, *SRC;
 register char *keys=(char*) akeys;
 register char *temp, *s, *d, *t;
 register int  i,j,k,ii,jj,a,b,pi,pj,pk;

 if (n <  2   ) return;
 temp = (char *) malloc(n*size*sizeof(char));

 k = SGMRG*size;
 for(a=0 , s=keys ; a < n ; a+= SGMRG  , s += k) {
      BGMRG(s, MIN(SGMRG  , (n-a)), size, compare);
 }

 s=keys; d=temp;
 for(a=SGMRG; a<n; a= (a+a)) {
     for(b=0; b<n; b += (a+a)) {
        ii=MIN(b+a,n);            jj=MIN(b+(a+a), n);
        i = b ;                    j=ii;      k = i; 
        pi=i*size;                 pj=j*size; pk=k*size;
        while ((i< ii) && (j< jj)) {
           if (compare(s+pj, s+pi)< 0) {
              MEMCPY(d+pk, s+pj, size);
              ++j; ++k; pj+=size; pk+=size;
           }
           else {
              MEMCPY(d+pk, s+pi, size);
              ++i;++k;  pi+=size; pk+=size;
           }
         }

         if (i< ii) MEMCPY(d+pk, s+pi, (ii-i)*size);
         if (j< jj) MEMCPY(d+pk, s+pj, (jj-j)*size);
      }
      t=s; s=d; d=t;
 }

  if (s!=keys) MEMCPY(keys,s,n*size);
  free(temp);
}

