/****(c) 2020. A. Gerbessiotis. See ../KAagcopy.txt ****/
/*******************************************************/
#include "aggssrt.h"

 /* QuickSort CAR Hoare original as it appears in Cormen et al circa page 160 */

void 
x61(void *akeys,int n,int size,int(*compare)(const void*,const void*),int l,int r)
{
 register int M;
 register char *SRC, *DES;
 register char *keys=(char*)akeys, *split, *tmp;
 register int i,j;

 if (l>=r) return;
 tmp  = (char *) malloc(size*sizeof(char));
 split= (char *) malloc(size*sizeof(char));

 memcpy(split,&keys[l*size],size);           /* SPLITTER: LEFTMOST FIXED */
 i=l; j=r+1;
 while (1) {
   do j--;
   while (compare(&keys[j*size],split) > 0) ;
   do i++;
   while (compare(&keys[i*size],split) < 0) ;
   if (i<j)  {
     MEMCPY(tmp,&keys[i*size],size);
     MEMCPY(&keys[i*size],&keys[j*size],size);
     MEMCPY(&keys[j*size],tmp,size);
   }
   else {
     MEMCPY(&keys[l*size],&keys[j*size],size);
     MEMCPY(&keys[j*size],split,size);
     break;
   }

 }
   M=j;
   x61(akeys,n,size,compare,l,M-1);
   x61(akeys,n,size,compare,M+1,r);
}

void g6carh1(void *keys,int n,int size,int (*compare)(const void*,const void *))
{
  if (n <= 1) return;
  x61(keys,n,size,compare,0,n-1);
}

char *
med3(char *a, char *b, char *c,int(*compare)(const void*,const void*)) 
{
   return(  compare(a,b) < 0 ?
            (compare(b,c)< 0 ? b : (compare(a,c) < 0 ? c : a ) ) :
            (compare(b,c)> 0 ? b : (compare(a,c) < 0 ? a : c ) ) );
}



 /* QuickSort CAR Hoare optimized */
void 
x62(void *akeys,int n,int size,int(*compare)(const void*,const void*),int l,int r)
{
  register int M;
  register char *SRC, *DES, CH;
  register char *keys = (char*) akeys;
  register int  i, j;
  register char *split, *pl,*pr,*pi,*pj;
  register int I,J,Z;
 /* register char *tmp; */
 /* tmp  = (char *) malloc(size*sizeof(char)); */
 if (l>=r) return;
 split= (char *) malloc(size*sizeof(char));

#if SPLITTER == MIDDLE_KEY
 MEMCPY(split,&keys[((l+r)>>1)*size],size);
if (n>8){
 pl=keys+l*size; pr=keys+r*size; pi=keys+ ((l+r)>>1)*size;
 pj=med3(pl,pi,pr,compare);
 MEMCPY(split,pj,size);
}
#elif SPLITTER == FIRST_KEY
 MEMCPY(split,&keys[l*size],size);
#elif SPLITTER == RANDOM_KEY
 MEMCPY(split,&keys[(l+GRANDOM((r-l+1)))*size],size);
#elif SPLITTER == MED3_KEY
if (n>8) {
 pl=keys+l*size; pr=keys+r*size; pi=keys+ ((l+r)>>1)*size;
 pj=med3(pl,pi,pr,compare);
 MEMCPY(split,pj,size);
} else {
 MEMCPY(split,&keys[((l+r)>>1)*size],size);
}
#endif
 i=l-1           ; j=r+1;
 pl= keys+i*size ; pr= keys+j*size ;

 while (1) {
   do {j--; pr -=size;}
   while (compare(pr,split) > 0) ;
   do {i++; pl +=size; }
   while (compare(pl,split) < 0) ;
   if (i<j)  {
   /* MEMCPY(tmp,pl,size); MEMCPY(pl,pr,size); MEMCPY(pr,tmp,size); */
      M=size;
      do { CH= *pl; *pl++ = *pr ; *pr++=CH; } 
      while (--M);
      pl-=size;pr-=size;
   }
   else  break;

 }
   Z=j;
   if ((Z-l+1) < SGQUI  ) {
            if ((Z-l+1) >1) {
               pi=&keys[l*size];
               for(J=1;J<(Z-l+1);J++){
                 MEMCPY(split,(pi+J*size),size);
                 I=J-1;pj=pi+I*size;
                 while ((I>=0) && (compare(pj,split)>0) ) {
                  MEMCPY((pj+size),(pj),size);
                  I--;pj-=size;
                 }
                 MEMCPY((pj+size),split,size);
            }

           }

   }
   else {
           x62(akeys,n,size,compare,l,Z);
   }

   if ((r-Z  ) < SGQUI  ) {
            if ((r-Z) >1) {
               pi=&keys[(Z+1)*size];
               for(J=1;J<(r-Z);J++){
                 MEMCPY(split,(pi+J*size),size);
                 I=J-1;pj=pi+I*size;
                 while ((I>=0) && (compare(pj,split)>0) ) {
                  MEMCPY((pj+size),(pj),size);
                  I--;pj-=size;
                 }
                 MEMCPY((pj+size),split,size);
            }
           }
    }
    else {
           x62 (akeys,n,size,compare,Z+1,r);
    }
}

void g6carh2(void *keys,int n,int size,int (*compare)(const void*,const void *))
{
  if (n <= 1) return ;
  x62 (keys,n,size,compare,0,n-1);
}



/* DISCARD : NOT WORKING PROPERLY; */

void 
x63(void *akeys,int n,int size,int(*compare)(const void*,const void*),int l,int r)
{
  register int M;
  register char *SRC, *DES, CH;
  register char *keys = (char*) akeys;
  register int  i, j;
  register char *split, *pl,*pr,*pi,*pj;
  register int I,J,Z;
  /* register char *tmp; */
  /* tmp  = (char *) malloc(size*sizeof(char)); */
  if (l>=r) return;
  split= (char *) malloc(size*sizeof(char));

#if SPLITTER == MIDDLE_KEY
 MEMCPY(split,&keys[((l+r)>>1)*size],size);
if (n>8){
 pl=keys+l*size; pr=keys+r*size; pi=keys+ ((l+r)>>1)*size;
 pj=med3(pl,pi,pr,compare);
 MEMCPY(split,pj,size);
}
#elif SPLITTER == FIRST_KEY
 MEMCPY(split,&keys[l*size],size);
#elif SPLITTER == RANDOM_KEY
 MEMCPY(split,&keys[(l+GRANDOM((r-l+1)))*size],size);
#elif SPLITTER == MED3_KEY
if (n>8){
 pl=keys+l*size; pr=keys+r*size; pi=keys+ ((l+r)>>1)*size;
 pj=med3(pl,pi,pr,compare);
 MEMCPY(split,pj,size);
} else {
 MEMCPY(split,&keys[((l+r)>>1)*size],size);
}
#endif
 i=l-1           ; j=r+1;
 pl= keys+i*size ; pr= keys+j*size ;

 while (1) {
   do {j--; pr -=size;}
   while (compare(pr,split) > 0) ;
   do {i++; pl +=size; }
   while (compare(pl,split) < 0) ;
   if (i<j)  {
   /* MEMCPY(tmp,pl,size); MEMCPY(pl,pr,size); MEMCPY(pr,tmp,size); */
      M=size;
      do {CH=*pl; *pl++=*pr; *pr++=CH; } 
      while (--M);
      pl-=size;pr-=size;
   }
   else  {    
     MEMCPY(&keys[l*size],&keys[j*size],size);
     MEMCPY(&keys[j*size],split,size);
     break;
   }


 }
   Z=j;
   if ((Z-l) < SGQUI  ) {
            if ((Z-l) >1) {   /* Subtle changes */
               pi= keys+l*size;
               for(J=1;J<(Z-l);J++){
                 MEMCPY(split,(pi+J*size),size);
                 I=J-1;pj=pi+I*size;
                 while ((I>=0) && (compare(pj,split)>0) ) {
                  MEMCPY((pj+size),(pj),size);
                  I--;pj-=size;
                 }
                 MEMCPY((pj+size),split,size);
            }

           }

   }
   else {
           x63(akeys,n,size,compare,l,Z-1);
   }
   if ((r-Z  ) < SGQUI  ) {
            if ((r-Z) >1) {
               pi=&keys[(Z+1)*size];
               for(J=1;J<(r-Z);J++){
                 MEMCPY(split,(pi+J*size),size);
                 I=J-1;pj=pi+I*size;
                 while ((I>=0) && (compare(pj,split)>0) ) {
                  MEMCPY((pj+size),(pj),size);
                  I--;pj-=size;
                 }
                 MEMCPY((pj+size),split,size);
            }
           }
    }
    else {
            x63(akeys,n,size,compare,Z+1,r);
    }

}

void 
g6carh3(void *keys, int n, int size, int (*compare) (const void*,const void *))
{
  if (n <= 1) return ;
  x63(keys,n,size,compare,0,n-1);
}

