/*******************************************************************
*******  Copyright (c)            Alexandros V. Gerbessiotis       *
******* All rights reserved; read copyag.txt file                  *
*******************************************************************/
#include "ssrt.h"

void ag23ins(void *akeys, int n, int size, int (*compare) (const void*,const void*))
{
 register int  M,i,j;
 register char *DES,*SRC, *tmp,*p;
 register char *keys= (char*) akeys;

 if (n <=1) return;
 tmp = (char *) malloc(size*sizeof(char));
 for(j=1;j<n;j++) {
   MEMCPY(tmp,(keys+j*size),size);
   i=j-1; p=keys+i*size;
   while ( (i>=0) && ( compare(p,tmp)>0) ) {
     MEMCPY((p+size),(p),size);
     --i;p-=size;
   }
   MEMCPY((p+size),tmp,size);
 }
 free((void *)tmp);
}
/*
*/

void ag21ins(void *akeys, int n, int size, int (*compare) (const void*,const void*))
{
 register int  M;
 register char *SRC,*DES,*p, *jp, *tmp;
 register char *keys= (char*) akeys ;
 if (n <=1) return;
 tmp = (char *) malloc(size*sizeof(char));
 for(jp=keys+size; jp<(keys+n*size); jp+=size) {
   MEMCPY(tmp,jp,size);
   p=jp-size;
   while ( (p>=keys) && ( compare(p,tmp)>0) ) {
     MEMCPY((p+size),(p),size);
     p-=size;
   }
   MEMCPY((p+size),tmp,size);
 }
 free((void *)tmp);
}
/*
*/
/* middle one ag21 ins is being used in quicksort
*/
void ag22ins(void *akeys, int n, int size, int (*compare) (const void*,const void*))
{
 register int  M;
 register char *DES,*SRC,*p, *jp, *tmp;
 register char *keys= (char*) akeys;
 if (n <=1) return;
 tmp = (char *) malloc(size*sizeof(char));
 for(jp=keys+size; jp<(keys+n*size); jp+=size) {
   MEMCPY(tmp,jp,size);
   for(p=jp;p > keys &&( compare(p-size,tmp)>0); p-=size){
     MEMCPY((p),(p-size),size);
   }
   MEMCPY((p),tmp,size);
 }
 free((void *)tmp);
}

