/*******************************************************************
*******  Copyright (c)            Alexandros V. Gerbessiotis       *
******* All rights reserved; read agcopy19.txt file                 *
*******************************************************************/
/*
#include <math.h>
*/
#include <stdio.h>
#include <sys/time.h>
#include "srtseq/agssrt.h"

#define ALL_FUNCTIONS
#undef  ALL_FUNCTIONS
#undef  FEW_FUNCTIONS
#define FEW_FUNCTIONS
#define NALGS 13

#define ELMNTS 8
#define MODULO 100000
#define MODULO_UINT ((unsigned int) 0x7FFFFFFF)
#define AVG_TINIT   AVG_PERRUN = AVG_ELAPSED =(double)0;
#define AVG_TSTART  AVG_PERRUN = (double) 0.0 ; avg_tstart();
#define AVG_TEND    avg_tend(); AVG_PERRUN = (avg_treturn() ); AVG_ELAPSED +=(AVG_PERRUN);
#define AVG_PERRUN  per_run
#define AVG_ELAPSED elapsed

static struct timeval avgtstart, avgtend;
static struct timezone avgtstruct;

void   avg_tstart  (void);
void   avg_tend    (void);
double avg_treturn (void);
void   printseq    (data *inp,int n,char *s,int debug);
void   dataseq     (data *d, int n, int type);
void   datacheck   (data *res, data *ori , int n);
void   seqdatacheck(data *ori , int n);

void   (*GTYPESORT)(void *,int,int,int (*) (const void *,const void *));


void avg_tstart(void) {
  gettimeofday(&avgtstart, &avgtstruct);
}

void avg_tend(void) {
  gettimeofday(&avgtend,&avgtstruct);
}

double avg_treturn(void) {
  double t1,t2;
  t1=(double)avgtstart.tv_sec + (double)avgtstart.tv_usec*(0.000001);
  t2=(double)  avgtend.tv_sec + (double)  avgtend.tv_usec*(0.000001);
  return(t2-t1);
}

int g1compare(const void *x,const void *y)
{
	return(int)(* ((data*)x)-*((data*)y));
}

int main(int argc,char *argv[]) {
  int j,k,n,runs, type, debug;
  data *ptr,*bptr, *sptr;
  double etime;

  void (*gfunc[NALGS])() = {  
    qsort    ,  q0gnu1    ,   ag48qwo   , ag49qwo   ,   ag30mi   ,  
    ag30mii  ,  ag43hx    ,   q5heapx1  , q5heapx2  ,   q5heapx3 ,
    q4mrgit1 ,  q4mrgit2  ,   qsort 
   };

  char *labels[NALGS]   = { 
    "qsort"   ,  "q0gnu1"  ,  "ag48qwo" ,  "ag49qwo" ,  "ag30mi"  ,
    "ag30mii" ,  "ag43hx"  ,  "q5heapx1",  "q5heapx2",  "q5heapx3",
    "q4mrgit1",  "q4mrgit2",  "qsort"   
   };

  int doalg[NALGS] = { 
    1,1,1,1,1,  1,1,1,1,1,  1,1,1
   };

   ptr=bptr=sptr=NULL;

   n=1000;   runs=1;
   if (( argc <= 1 ) || (argc > 5)) {
             printf("Usage: %s n type runs debug\n",argv[0]);
             printf("Type : 1=rand MODULO_UINT, 2=rand (INT_MAX), 3= INC, 4= 17  else= DEC\n");
             printf("Quick: BSRTSZE=%d RQSSZE=%d SPLITTER=%d\n",BSRTSZE,RQSSZE,SPLITTER); 
             printf("Split:  0:left, 1:middle, 2:random\n");
             return(1);
   } 
     else {
             n    = atoi(argv[1]);  /*  size  */
             type = atoi(argv[2]);  /*  type  */
             runs = atoi(argv[3]);  /*  runs  */
             debug= atoi(argv[4]);  /*  debug */
             printf("%d : %d %d %d %d\n",argc,n,type,runs,debug);
   }
   etime=0.0;
   sptr= (data *) malloc(n*sizeof(data));
   bptr= (data *) malloc(n*sizeof(data));
   ptr = (data *) malloc(n*sizeof(data));
   memset( ptr,0,n*sizeof(data));
   memset(bptr,0,n*sizeof(data));
   memset(sptr,0,n*sizeof(data));

   dataseq(bptr,n,type);
   printseq(bptr,n,"InQ",debug);
   memcpy(ptr,bptr,n*sizeof(data));

   qsort(ptr,n,sizeof(data),g1compare);
   printseq( ptr,n,"OtQ",debug);
   memcpy(sptr,ptr,n*sizeof(data));

   for(k=0;k<NALGS;k++) {
      if (doalg[k]>=1) {
         GTYPESORT=gfunc[k];
         etime=0.0;

         for(j=0;j<runs;j++) {
            memcpy(ptr,bptr,n*sizeof(data));
            avg_tstart();
               GTYPESORT(ptr,n,sizeof(data),g1compare);
            avg_tend();
            etime += (avg_treturn());
         }
/*       memcmp 3 lines below does not tell you which keys are out of sequence
*/
         datacheck(ptr,sptr,n);

      if (memcmp(ptr,sptr,n*sizeof(data))  != 0){
         printf("NO:%2d:%2d:%1d:%10d:%1d:%2d:%1d:",BSRTSZE,RQSSZE,SPLITTER,n,type,runs,debug);
         printf(   "%11s : %12.8f : %12.3f\n",labels[k],etime,etime/runs);
      }
      else {
         printf("%2d:%2d:%1d:%10d:%1d:%2d:%1d:",BSRTSZE,RQSSZE,SPLITTER,n,type,runs,debug);
         printf(   "%11s : %12.8f : %12.3f\n",labels[k],etime,etime/runs);
         fflush(stdout);
      }
      }
   }

   free((void *) ptr);
   free((void *) bptr);
   free((void *) sptr);
   return(0);
}

void printseq(data *inp, int n, char *s, int debug) 
{
 register int i;
 if (1==debug)  { 
 fprintf(stdout,"[%4s]: ",s);
 fflush(stdout);
 for(i=0;i<ELMNTS;i++){
   fprintf(stdout,"%10d,", (data) inp[i]);
 }
   fprintf(stdout,"...\n          ");
 for(i=n-ELMNTS;i<n;i++){
   fprintf(stdout,"%10d,", (data) inp[i]);
 }
 fprintf(stdout,"\n");
 fflush(stdout);
 }
}

void dataseq  (data *d, int n, int type)
{
 register int i;
    srandom(21+1001*11);
    if (type == 1) {
        for (i=0;i<n;i++) {
           d[i]= (data ) (random() & MODULO_UINT);
        }
     } 
     else 
     if (type == 2) {
         for (i=0;i<n;i++) {
            d[i]= (data )  ((n)*(random()/((double)INT_MAX)));
         }
     }
     else
     if (type == 3) {
         for (i=0;i<n;i++) {
            d[i]= (data )  (i+1);
         }
     }
     else
     if (type == 4) {
         for (i=0;i<n;i++) {
            d[i]= (data )  (17);
         }
     }
     else {
       for (i=0;i<n;i++) {
         d[i]= (data )  (n-i);
       }
     }
}



void seqdatacheck (data *ori, int n)
{
  register int i;
   for(i=0;i<n-1;i++) {
     if (ori[i] > ori[i+1]) {
      fprintf(stdout,"\nError at %d : %d noteq %d\n",i,ori[i],ori[i+1]);
      fflush(stdout); 
      return;
     }
   }
   fprintf(stdout,"OK:"); fflush(stdout);
}

void datacheck (data *res, data *ori , int n)
{
  register int i;
   for(i=0;i<n;i++) {
     if (res[i] != ori[i]) {
      fprintf(stdout,"\nError at %d : %d noteq %d\n",i,res[i],ori[i]);
      fflush(stdout);
      return;
     }
   }
   fprintf(stdout,"OK:");fflush(stdout);
}

