/**** 2019 (c)  All rights reserved: see agcopy19.txt ****/

#include "agssrt.h"
#ifndef MEMCPY
#define MEMCPY(X,Y,SIZE)  memcpy((X),(Y),(SIZE))
#endif

 /* QuickSort Recursive using do ; inline memcpy ; static x,y ;  simple version  */
void q6qkrd0a(void *akeys, int n, int size, int (*compare) (const void*,const void*),int l,int r)
{
 register int M;
 register char *DES,*SRC;
 register char *keys=(char*)akeys;
 char *split,*tmp;
 register int i,j;

 if (n<=1) return;
 tmp  = (char *) malloc(size*sizeof(char));
 split= (char *) malloc(size*sizeof(char));
 i=l;j=r;
#if SPLITTER == MIDDLE_KEY
 MEMCPY(split,&keys[((l+r)>>1)*size],size);
#elif SPLITTER == FIRST_KEY
 MEMCPY(split,&keys[l*size],size);
#elif SPLITTER == RANDOM_KEY
 MEMCPY(split,&keys[(l+GRANDOM((r-l+1)))*size],size);
#endif

 do {
   while (compare(&keys[i*size],split) < 0) ++i;
   while (compare(split,&keys[j*size]) < 0) --j;
   if (i <= j ) {
     MEMCPY(tmp,&keys[i*size],size);
     MEMCPY(&keys[i*size],&keys[j*size],size);
     MEMCPY(&keys[j*size],tmp,size);
     ++i;--j;
   }
 } while (i <= j);

 if (l < j) {
   if ((j-l+1) < RQSSZE )
     RQSIS  (keys+l*size,(j-l+1),size,compare);
   else
     q6qkrd0a(keys,n,size,compare,l,j);
 }

  if (i < r) {
    if ((r-i+1) < RQSSZE )
      RQSIS  (keys+i*size,(r-i+1),size,compare);
  else
      q6qkrd0a(keys,n,size,compare,i,r);
  }

 free((void *)split); free((void *)tmp);
}

void q6qkrd0(void *keys, int n, int size, int (*compare) (const void*,const void *))
{
  if (n <= 1) return ;
#if SPLITTER == RANDOM_KEY
 GSRANDOM();
#endif
  q6qkrd0a (keys,n,size,compare,0,n-1);
}


void q6qkrd1a(void *akeys, int n, int size, int (*compare) (const void*,const void*),int l,int r)
{
 register int i,j,m,c;
 static char x[64];
 register char *keys=(char*) akeys;
 register char *pi,*pj;

 i=l;j=r;
 pi=  keys+l*size ;
 pj=  keys+r*size ;
/*
 x = (char *) malloc(size*sizeof(char));
 y = (char *) malloc(size*sizeof(char));
*/
 memcpy(x,keys+((l+r)>>1)*size,size);
 do {
        while (compare(pi,x) < 0)  {++i; pi += size;}
        while (compare(x,pj) < 0)  {--j; pj -= size;}
        if (i <= j ) {
        /* memcpy(y,pi,size);
        memcpy(pi,pj,size);
        memcpy(pj,y,size);
        ++i;--j; pi += size;pj -= size; */
        m=size;
        do  {
             c=*pi; *pi++=*pj;*pj++=c;} while (--m);
                ++i;--j;pj-=size;pj-=size;
        }
 } while (i <= j);

        if (l < j) {
                if ((j-l) < RQSSZE )
                        RQSIS(keys+l*size ,(j-l+1),size,compare);
                else
                        q6qkrd1a(keys,n,size,compare,l,j);
        }
        if (i < r) {
                if ((r-i) < RQSSZE )
                        RQSIS(keys+i*size,(r-i+1),size,compare);
                else
                        q6qkrd1a(keys,n,size,compare,i,r);
        }

/*
 free((void *)x); free((void *)y);
*/
}


void q6qkrd1(void *keys, int n, int size, int (*compare) (const void*,const void *))
{
  q6qkrd1a(keys,n,size,compare,0,n-1);
}



 /* QuickSort Recursive using do ; inline memcpy ; inline insertion sort ;  static x  Tail recursion */
void q6qkrd2a (void *akeys, int n, int size, int (*compare) (const void*,const void*),int l,int r)
{
 register int M;
 register char *SRC, *DES;
 register char *keys=(char*) akeys;
 register char *x,*pi,*pj,*pp;
 register int i,j,c;
 static char X[64];

 x=X;
 i=l;j=r;
 pi= keys+l*size;
 pj= keys+r*size;

 MEMCPY(x,&keys[((l+r)>>1)*size],size);

do
{
        while (compare(pi,x) < 0)  {++i; pi += size;}
        while (compare(x,pj) < 0)  {--j; pj -= size;}
        if (i <= j ) {
          M=size;
          do  {
             c=*pi; *pi++=*pj;*pj++=c;} while (--M);
                i++;j--;pj-=size;pj-=size;
        }
} while (i <= j);

        if (l < j) {
                if ((j-l) < RQSSZE ) {
                   pi=keys+l*size;
                   for(pj=pi+size;pj< pi+(j-l+1)*size;pj+=size){
                     MEMCPY(x,pj,size);
                     for(pp=pj;pp > pi &&(compare(pp-size,x)>0); pp-=size){
                       MEMCPY((pp),(pp-size),size);
                     }
                     MEMCPY((pp),x,size);
                   }
                }
                else
                        q6qkrd2a  (keys,n,size,compare,l,j);
        }
        if (i < r) {
                if ((r-i) < RQSSZE ) {
                   pi=keys+i*size;
                   for(pj=pi+size;pj< pi+(r-i+1)*size;pj+=size){
                     MEMCPY(x,pj,size);
                     for(pp=pj;pp > pi &&(compare(pp-size,x)>0); pp-=size){
                       MEMCPY((pp),(pp-size),size);
                     }
                     MEMCPY((pp),x,size);
                   }
                }
                else
                        q6qkrd2a  (keys,n,size,compare,i,r);
        }


}

void q6qkrd2 (void *keys, int n, int size, int (*compare) (const void*,const void *))
{
  if (n<=1) return;
  q6qkrd2a  (keys,n,size,compare,0,n-1);
}


 /* QuickSort Recursive using do ; inline memcpy ; inline insertion sort ;  static x  Tail recursion */
void q6qkrd3a (void *akeys, int n, int size, int (*compare) (const void*,const void*),int *L,int *R)
{
 register int M;
 register char *SRC, *DES;
 register int i,j,c,l,r;
/*
 static char X[64];
*/
 register char *keys=(char*) akeys;
 register char *x,*pi,*pj,*pp;

 l=*L;r=*R;
/*
 x=X;
*/
 x=(char *) malloc(size*sizeof(char));

 while (l < r) {
    i=l;j=r;
    pi= keys+l*size;
    pj= keys+r*size;

    MEMCPY(x,keys+((l+r)>>1)*size ,size);

   do {
        while (compare(pi,x) < 0)  {++i; pi += size;}
        while (compare(x,pj) < 0)  {--j; pj -= size;}
        if (i <= j ) {
          M=size;
          do  {
             c=*pi; *pi++=*pj;*pj++=c;} while (--M);
                ++j;--j;pj-=size;pj-=size;
        }
    } while (i <= j);

     if ((j-l)<(r-i)) {
       *L=l; *R=j;
       if (l<j) {
         if ((j-l) < RQSSZE ) {
                   pi=keys+l*size;
                   for(pj=pi+size;pj< pi+(j-l+1)*size;pj+=size){
                     MEMCPY(x,pj,size);
                     for(pp=pj;pp > pi &&(compare(pp-size,x)>0); pp-=size){
                       MEMCPY((pp),(pp-size),size);
                     }
                     MEMCPY((pp),x,size);
                   }
         }
         else
                        q6qkrd3a  (keys,n,size,compare,L,R);
       }
       l=i;
     }
     else  {
       *L=i; *R=r;
       if (i<r) {
         if((r-i) < RQSSZE ) {
                  pi=keys+i*size;
                   for(pj=pi+size;pj< pi+(r-i+1)*size;pj+=size){
                     MEMCPY(x,pj,size);
                     for(pp=pj;pp > pi &&(compare(pp-size,x)>0); pp-=size){
                       MEMCPY((pp),(pp-size),size);
                     }
                     MEMCPY((pp),x,size);
                   }
         }
         else
                        q6qkrd3a  (keys,n,size,compare,L,R);
       }
       r=j;
     }

}
}

void q6qkrd3 (void *keys, int n, int size, int (*compare) (const void*,const void *))
{
  int L,R;
  if (n<=1) return;
  L=0;R=n-1;
  q6qkrd3a  (keys,n,size,compare,&L,&R);
}

 /* QuickSort Recursive using do ; inline memcpy ; inline insertion sort ;  static x  Tail recursion */
void q6qkrd4a (void *akeys, int n, int size, int (*compare) (const void*,const void*),int l,int r)
{
 register int M;
 register char *SRC, *DES;
 register char *keys=(char*) akeys;
 register int i,j,c,I,J;
 register char *pi,*pj,*tmp,*split;

 if (n<=1) return;
 keys  = (char *) akeys;
 tmp   = (char *) malloc(size*sizeof(char));
 split = (char *) malloc(size*sizeof(char));
 i=l;j=r;
 pi= &keys[l*size];
 pj= &keys[r*size];
#if SPLITTER == MIDDLE_KEY
 memcpy(split,&keys[((l+r)>>1)*size],size);
#elif SPLITTER == FIRST_KEY
 memcpy(split,&keys[l*size],size);
#elif SPLITTER == RANDOM_KEY
 memcpy(split,&keys[(l+GRANDOM((r-l+1)))*size],size);
#endif

 do {
   while (compare(pi,split) < 0)  {i++; pi += size;}
   while (compare(split,pj) < 0)  {j--; pj -= size;}
   if (i <= j ) {
   /* MEMCPY(tmp,pi,size); MEMCPY(pi,pj,size); MEMCPY(pj,tmp,size); i++;j--;pi += size;pj -= size; */
            M=size;
            do {
             c=*pi; *pi++ = *pj; *pj++=c;
            } while (--M);
            i++; pj -=size;
            j--; pj -=size;

   }
 } while (i <= j);
 if (l < j) {
   if ((j-l+1) < RQSSZE ) {
/*
      BASES (&keys[l*size],(j-l+1),size,compare);
*/
            if ((j-l+1) >1) {
               pi=&keys[l*size];
               for(J=1;J<(j-l+1);J++){
                 MEMCPY(split,(pi+J*size),size);
                 I=J-1;pj=pi+I*size;
                 while ((I>=0) && (compare(pj,split)>0) ) {
                  MEMCPY((pj+size),(pj),size);
                  I--;pj-=size;
                 }
                 MEMCPY((pj+size),split,size);
            }
           }

   }
   else {
      q6qkrd4a(keys,n,size,compare,l,j);
   }
  }
  if (i < r) {
    if ((r-i+1) < RQSSZE ) {
/*
        BASES (&keys[i*size],(r-i+1),size,compare);
*/
            if ((r-i+1) >1) {
               pi=&keys[i*size];
               for(J=1;J<(r-i+1);J++){
                 MEMCPY(split,(pi+J*size),size);
                 I=J-1;pj=pi+I*size;
                 while ((I>=0) && (compare(pj,split)>0) ) {
                  MEMCPY((pj+size),(pj),size);
                  I--;pj-=size;
                 }
                 MEMCPY((pj+size),split,size);
            }
           }
    }
    else {
        q6qkrd4a(keys,n,size,compare,i,r);
    }
  }

 free((void *)split); free((void *)tmp);
}


void q6qkrd4 (void *keys, int n, int size, int (*compare) (const void*,const void *))
{
  if (n<=1) return;
#if SPLITTER == RANDOM_KEY
 GSRANDOM();
#endif
  q6qkrd4a  (keys,n,size,compare,0,n-1);
}
