/**** 2019 (c)  All rights reserved: see agcopy19.txt ****/

#include "agssrt.h"
#ifndef MEMCPY
#define MEMCPY(X,Y,SIZE)  memcpy((X),(Y),(SIZE))
#endif
 /* (Straight) Insertion Sort */

void q1ins1(void *akeys, int n, int size, int (*compare) (const void*,const void*))
{  /* j=i-1 */
 register int M;
 register char *SRC, *DES;
 register int i,j;
 register char *k,*keys=(char*)akeys;

 if (n <= 1) return;
 k    = (char *) malloc(size*sizeof(char));

 for(i=1;i<n;++i) {
    MEMCPY(k, keys+i*size, size); /* keys[i*size] */
    j=i-1;
    while ( (j >= 0 ) && (compare(keys+j*size, k ) > 0 )) {
       MEMCPY(keys+j*size+size, keys+j*size, size);  /* (j+1)*size=j*size+size */
       --j;
    }
    MEMCPY(keys+(j+1)*size, k, size);
 }
 free((void*) k );
}

void q1ins2(void *akeys, int n, int size, int (*compare)(const void*,const void*))
{   /* j=i */
 register int M;
 register char *SRC, *DES;
 register int i,j;
 register char *k,*keys=(char*)akeys;

 if (n <= 1) return;
 k    = (char *) malloc(size*sizeof(char));

 for(i=1;i<n;++i){
    MEMCPY(k, keys+i*size, size);
    j=i;
    while ( (j >  0 ) && (compare(keys+(j-1)*size, k ) > 0 )){
       MEMCPY(keys+j*size, keys+j*size-size, size);
       --j;
    }
    MEMCPY(keys+j*size, k, size);
 }
 free((void*) k );
}


void q1ins3(void *akeys, int n, int size, int (*compare) (const void*,const void*))
{   /* j=i-1 , p */
 register int M;
 register char *SRC, *DES;
 register int i,j;
 register char *k, *keys=(char*)akeys, *p;

 if (n <= 1) return;
 k    = (char *) malloc(size*sizeof(char));

 for(i=1;i<n;++i) {
    MEMCPY(k, keys+i*size, size);
    j=i-1;  p = keys+j*size;
    while ( (j >= 0 ) && (compare(p, k ) > 0 )) {
       MEMCPY(p+size, p, size);
       --j; p -= size;
    }
    MEMCPY( p+size, k, size);
 }
 free((void *) k );
}

void q1ins4(void *akeys, int n, int size, int (*compare)(const void*,const void*))
{   /* j=i , p */
 register int M;
 register char *SRC, *DES;
 register int i,j;
 register char *k, *keys=(char*)akeys, *p;

 if (n <= 1) return;
 k    = (char *) malloc(size*sizeof(char));

 for(i=1;i<n;++i){
    MEMCPY(k, keys+i*size, size);
    j=i; p = keys+(j-1)*size;
    while ( (j >  0 ) && ( compare(p, k ) > 0 )){
       MEMCPY(p+size, p, size);
       --j; p-= size;
    }
    MEMCPY(p+size, k, size);
 }
 free((void*) k );
}

void q1ins5(void *akeys, int n, int size, int (*compare) (const void*,const void*))
{   /* j=ip , p */
 register int  M;
 register char *SRC, *DES;
 register char *k, *keys=(char*)akeys, *p, *ip;

 if (n <=1) return;
 k    = (char *) malloc(size*sizeof(char));

 for(ip=keys+size; ip< (keys+n*size); ip += size) {
    MEMCPY(k, ip, size);
    p=ip-size;
    while ( (p >= keys ) && (compare(p,k) > 0 )) {
       MEMCPY(p+size, p, size);
       p-=size;
    }
    MEMCPY((p+size), k, size);
 }
 free((void*) k );
}

void q1ins7(void *akeys, int n, int size, int (*compare) (const void*,const void*))
{
 register int  M;
 register char *SRC, *DES;
 register char *k, *keys=(char*)akeys, *p, *ip;

 if (n <=1) return;
 k    = (char*) malloc(size*sizeof(char));

 for(ip=keys+size; ip < (keys+n*size) ; ip += size) {
    MEMCPY(k, ip, size);
    for( p = ip ; (p > keys ) && (compare(p-size, k) > 0 ); p-=size){
       MEMCPY(p,p-size,size);
    }
    MEMCPY(p, k, size);
 }
 free((void *) k );
}



#ifdef BUGGY_TO_DEBUG
void g1insZ(void *akeys, int n, int size, int (*compare) (const void*,const void*))
{
 register int i,j,                m;
 register char *k,*keys,*t,*u;
 char   *X;

 if (n <=1) return;
 keys=(char *)akeys;
 X = (char *) malloc(size*sizeof(char));
 k=X;
 for(j=1;j<n;++j) {
   MEMCPY(k,(keys+j*size),size);
   i=j-1;
   while ( (i>=0) && ( compare(&keys[i*size],k)>0) ) {
     MEMCPY((keys+i*size+size),(keys+i*size),size);
     i--;
   }
#ifdef ALTER
   MEMCPY(keys+i*size,keys+i*size+size,size);
#endif
   /*                     --- t=k is suspect */
   t=keys+i*size;u=t+size;t=k;m=size; do{ *t++ = *u++ ;} while (--m);
 }
 free(k);
}
void q1ins8(void *akeys, int n, int size, int (*compare) (const void*,const void*))
{
 register int  M;
 register char *SRC, *DES;
 register char     *keys=(char*)akeys, *p, *ip;

 if (n <=1) return;

 for(ip=keys+size; ip < (keys+n*size) ; ip += size) {
    for( p = ip ; (p > keys ) && (compare(p-size,ip) > 0); p-=size){
       MEMCPY(p,p-size,size);
    }
    MEMCPY(p+size, ip,size);
 }
}
#endif

