/**** 2019 (c)  All rights reserved: see agcopy19.txt ****/

#include "agssrt.h"
#ifndef MEMCPY
#define MEMCPY(X,Y,SIZE)  memcpy((X),(Y),(SIZE))
#endif
 /* Shake Sort */


void g3shake1(void *akeys,int n,int size,int (*compare) (const void*,const void*))
{
 register int M;
 register char *SRC, *DES;
 register int  j,k,l,r;
 register char *x,*keys;

 if (n<=1) return;
 keys = (char *) akeys;
 x    = (char *) malloc(size*sizeof(char));

 l=1;r=n-1;k=n-1;
 do {
    for(j=r;j>=l;j--) {
      if (compare(keys+(j-1)*size,keys+j*size) > 0) {
        MEMCPY(x,keys+(j-1)*size,size);
        MEMCPY(keys+(j-1)*size,keys+j*size,size);
        MEMCPY(keys+j*size,x,size);
        k=j;
      }
    }
    l=k+1;
    for(j=l;j<=r;++j) {
      if (compare(keys+(j-1)*size,keys+j*size) > 0) {
        MEMCPY(x,keys+(j-1)*size,size);
        MEMCPY(keys+(j-1)*size,keys+j*size,size);
        MEMCPY(keys+j*size,x,size);
        k=j;
      }
    }
    r=k-1;
  } while (l <= r);
 free((void*)x);
}

void q3shake2(void *akeys, int n, int size, int (*compare) (const void*,const void*))
{  
 register int j,k,l,r,c,m;
 register char	*x,*keys,*T,*U;

 if (n <= 1) return;
 keys = (char *) akeys;
 x    = (char *) malloc(size*sizeof(char));

 l=1;r=n-1;k=n-1;
 do {
    for(j=r;j>=l;j--) {
      if (compare(keys+(j-1)*size,keys+j*size) > 0) {
        T=keys+(j-1)*size; U=T+size; m=size;
        do {
         c= *T;
         *T++ = *U;
         *U++ = c;
        } while (--m);
        k=j;
      }
    }
    l=k+1;
    for(j=l;j<=r;++j) {
      if (compare(keys+(j-1)*size,keys+j*size) > 0) {
        T=keys+(j-1)*size; U=T+size; m=size;
        do {
         c= *T;
         *T++ = *U;
         *U++ = c;
        } while (--m);
        k=j;
      }
    }
    r=k-1;
 } while (l <= r);
 free((void*)x);
}
