/**** 2019 (c)  All rights reserved: see agcopy19.txt ****/

#include "agssrt.h"
#ifndef MEMCPY
#define MEMCPY(X,Y,SIZE)  memcpy((X),(Y),(SIZE))
#endif
 /* Iterative MergeSort with inline InsertionSort base case */


void q4mrgit1(void *keys, int n, int size, int (*compare) (const void*,const void*))
{  
 register int M;
 register char *SRC, *DES;
 register char *S, *D, *T, *kys;
 register int i, j, k, r, t, LB, RB;
 char     *ktmp;

 if (n <  2   ) return;   
 if (size < 1 ) return;
 kys  = (char *) keys ;   
 ktmp = (char *) malloc(n*size*sizeof(char));

 for(t=0; t < n ; t+=BSRTSZE) {
    MRGBSRT(kys + t*size, MIN(BSRTSZE, (n-t)), size, compare);
 }

 S=kys; D=ktmp;
 for(r= BSRTSZE ; r < n ; r = (r<<1)) {
     for(t=0 ; t < n; t += (r<<1)) {
        LB=MIN(t+r, n); RB=MIN(t+(r<<1), n); 
        i = t ; j = LB ; k = t;
        while ((i< LB) && (j< RB)) {
/*
           if (compare(S+i*size, S+j*size)<=0) {
              MEMCPY(D+k*size, S+i*size, size);
              ++i; ++k;
           }
           else {
              MEMCPY(D+k*size, S+j*size, size);
              ++j;++k;
           }
*/
           if (compare(S+j*size, S+i*size)< 0) {
              MEMCPY(D+k*size, S+j*size, size);
              ++j; ++k;
           }
           else {
              MEMCPY(D+k*size, S+i*size, size);
              ++i;++k;
           }
         }

         if (i< LB) MEMCPY(D+k*size, S+i*size, (LB-i)*size);  
         if (j< RB) MEMCPY(D+k*size, S+j*size, (RB-j)*size);
      }
      T=S; S=D; D=T;
 }

  if (S!=kys) MEMCPY(kys,S,n*size);

  free(ktmp);
}

void q4mrgit2 (void *keys,int n,int size,int (*compare)(const void*,const void*) )
{   /* eliminates most  * size  */
 register int M;
 register char *SRC, *DES;
 register char *S, *D, *T, *kys;
 register int i, j, k, r, t, LB, RB, pi,pj,pk;
 char     *ktmp;

 if (n <  2   ) return;
 if (size < 1 ) return;
 kys  = (char *) keys ;
 ktmp = (char *) malloc(n*size*sizeof(char));

 r = BSRTSZE * size;
 for(t=0 , S=kys ; t < n ; t+= BSRTSZE, S += r) {
    MRGBSRT(S, MIN(BSRTSZE, (n-t)), size, compare);
 }

 S=kys; D=ktmp;
 for(r= BSRTSZE ; r < n ; r = (r<<1)) {
     for(t=0 ; t < n; t += (r<<1)) {
        LB=MIN(t+r, n); RB=MIN(t+(r<<1), n);
        i = t ; j = LB ; k = t; pi=i*size; pj=j*size; pk=k*size;
        while ((i< LB) && (j< RB)) {
           if (compare(S+pj, S+pi)< 0) {
              MEMCPY(D+pk, S+pj, size);
              ++j; ++k; pj+=size; pk+=size;
           }
           else {
              MEMCPY(D+pk, S+pi, size);
              ++i;++k;  pi+=size; pk+=size;
           }
         }

         if (i< LB) MEMCPY(D+pk, S+pi, (LB-i)*size);
         if (j< RB) MEMCPY(D+pk, S+pj, (RB-j)*size);
      }
      T=S; S=D; D=T;
 }

  if (S!=kys) MEMCPY(kys,S,n*size);
  free(ktmp);
}

void q4mrgit3(void *keys, int n, int size, int (*compare) (const void*,const void*))
{  
 register int M;
 register char *SRC, *DES;
 register char *S, *D, *T, *kys;
 register int i, j, k, r, t, LB, RB;
 char     *ktmp;

 if (n <  2   ) return;   
 if (size < 1 ) return;
 kys  = (char *) keys ;   
 ktmp = (char *) malloc(n*size*sizeof(char));

 for(t=0; t < n ; t+=BSRTSZE) {
    MRGBSRT(kys + t*size, MIN(BSRTSZE, (n-t)), size, compare);
 }

/* */
      tmp=keys;
      for(s=tmp+size;s<tmp+TMERGE*size;s+=size){
        MEMCPY(temp,s,size);
        for(t=s;t > tmp &&(compare(t-size,temp)>0);t-=size){
          MEMCPY((t),(t-size),size);
        }
        MEMCPY((t),temp,size);
      }
/* */

 S=kys; D=ktmp;
 for(r= BSRTSZE ; r < n ; r = (r<<1)) {
     for(t=0 ; t < n; t += (r<<1)) {
        LB=MIN(t+r, n); RB=MIN(t+(r<<1), n); 
        i = t ; j = LB ; k = t;
        while ((i< LB) && (j< RB)) {
/*
           if (compare(S+i*size, S+j*size)<=0) {
              MEMCPY(D+k*size, S+i*size, size);
              ++i; ++k;
           }
           else {
              MEMCPY(D+k*size, S+j*size, size);
              ++j;++k;
           }
*/
           if (compare(S+j*size, S+i*size)< 0) {
              MEMCPY(D+k*size, S+j*size, size);
              ++j; ++k;
           }
           else {
              MEMCPY(D+k*size, S+i*size, size);
              ++i;++k;
           }
         }

         if (i< LB) MEMCPY(D+k*size, S+i*size, (LB-i)*size);  
         if (j< RB) MEMCPY(D+k*size, S+j*size, (RB-j)*size);
      }
      T=S; S=D; D=T;
 }

  if (S!=kys) MEMCPY(kys,S,n*size);

  free(ktmp);
}

void q4mrgit4 (void *keys,int n,int size,int (*compare)(const void*,const void*) )
{   /* eliminates most  * size  */
 register int M;
 register char *SRC, *DES;
 register char *S, *D, *T, *kys;
 register int i, j, k, r, t, LB, RB, pi,pj,pk;
 char     *ktmp;

 if (n <  2   ) return;
 if (size < 1 ) return;
 kys  = (char *) keys ;
 ktmp = (char *) malloc(n*size*sizeof(char));

 r = BSRTSZE * size;
 for(t=0 , S=kys ; t < n ; t+= BSRTSZE, S += r) {
    MRGBSRT(S, MIN(BSRTSZE, (n-t)), size, compare);
 }
/* */
      tmp=keys;
      for(s=tmp+size;s<tmp+TMERGE*size;s+=size){
        MEMCPY(temp,s,size);
        for(t=s;t > tmp &&(compare(t-size,temp)>0);t-=size){
          MEMCPY((t),(t-size),size);
        }
        MEMCPY((t),temp,size);
      }
/* */

 S=kys; D=ktmp;
 for(r= BSRTSZE ; r < n ; r = (r<<1)) {
     for(t=0 ; t < n; t += (r<<1)) {
        LB=MIN(t+r, n); RB=MIN(t+(r<<1), n);
        i = t ; j = LB ; k = t; pi=i*size; pj=j*size; pk=k*size;
        while ((i< LB) && (j< RB)) {
           if (compare(S+pj, S+pi)< 0) {
              MEMCPY(D+pk, S+pj, size);
              ++j; ++k; pj+=size; pk+=size;
           }
           else {
              MEMCPY(D+pk, S+pi, size);
              ++i;++k;  pi+=size; pk+=size;
           }
         }

         if (i< LB) MEMCPY(D+pk, S+pi, (LB-i)*size);
         if (j< RB) MEMCPY(D+pk, S+pj, (RB-j)*size);
      }
      T=S; S=D; D=T;
 }

  if (S!=kys) MEMCPY(kys,S,n*size);
  free(ktmp);
}
