/**** 2019 (c)  All rights reserved: see agcopy19.txt ****/
#include "agssrt.h"

 /* QuickSort CAR Hoare original as it appears in Cormen et al circa page 160 */

void q6carh1a(void *akeys, int n, int size, int (*compare) (const void*,const void*),int l,int r)
{
 register int M;
 register char *SRC, *DES;
 register char *keys=(char*)akeys;
 char *split,*tmp;
 register int i,j;

 if (l>=r) return;
 tmp  = (char *) malloc(size*sizeof(char));
 split= (char *) malloc(size*sizeof(char));

 memcpy(split,&keys[l*size],size);
 i=l; j=r+1;
 while (1) {
   do j--;
   while (compare(&keys[j*size],split) > 0) ;
   do i++;
   while (compare(&keys[i*size],split) < 0) ;
   if (i<j)  {
     MEMCPY(tmp,&keys[i*size],size);
     MEMCPY(&keys[i*size],&keys[j*size],size);
     MEMCPY(&keys[j*size],tmp,size);
   }
   else {
     MEMCPY(&keys[l*size],&keys[j*size],size);
     MEMCPY(&keys[j*size],split,size);
     break;
   }

 }
   M=j;
   q6carh1a(akeys,n,size,compare,l,M-1);
   q6carh1a(akeys,n,size,compare,M+1,r);
}

void q6carh1  (void *keys, int n, int size, int (*compare) (const void*,const void *))
{
  if (n <= 1) return ;
  q6carh1a(keys,n,size,compare,0,n-1);
}





 /* QuickSort CAR Hoare original as it appears in Cormen et al circa page 160 */
 /* Of course inline f-w insertion sort and other optimizations   */
void q6carh2a(void *akeys, int n, int size, int (*compare) (const void*,const void*), int l, int r)
{
  register int M;
  register char *SRC, *DES;
  register char *keys = (char*) akeys;
  register int  i, j,c;
  register char *split, *pl,*pr,*pi,*pj;
  register int I,J,Z;
  /* register char *tmp; */
 if (l>=r) return;

 keys = (char *) akeys;
 /* tmp  = (char *) malloc(size*sizeof(char)); */
 split= (char *) malloc(size*sizeof(char));

#if SPLITTER == MIDDLE_KEY
 MEMCPY(split,&keys[((l+r)>>1)*size],size);
#elif SPLITTER == FIRST_KEY
 MEMCPY(split,&keys[l*size],size);
#elif SPLITTER == RANDOM_KEY
 MEMCPY(split,&keys[(l+GRANDOM((r-l+1)))*size],size);
#endif
 i=l-1           ; j=r+1;
 pl= keys+i*size ; pr= keys+j*size ;

 while (1) {
   do {j--; pr -=size;}
   while (compare(pr,split) > 0) ;
   do {i++; pl +=size; }
   while (compare(pl,split) < 0) ;
   if (i<j)  {
   /* MEMCPY(tmp,pl,size); MEMCPY(pl,pr,size); MEMCPY(pr,tmp,size); */
          M=size;
          do {
            c= *pl; *pl++ = *pr ; *pr++=c;
            } while (--M);
                pl-=size;pr-=size;
   }
   else  break;

 }
   Z=j;
   if ((Z-l+1) < RQSSZE ) {
            if ((Z-l+1) >1) {
               pi=&keys[l*size];
               for(J=1;J<(Z-l+1);J++){
                 MEMCPY(split,(pi+J*size),size);
                 I=J-1;pj=pi+I*size;
                 while ((I>=0) && (compare(pj,split)>0) ) {
                  MEMCPY((pj+size),(pj),size);
                  I--;pj-=size;
                 }
                 MEMCPY((pj+size),split,size);
            }

           }

   }
   else {
           q6carh2a (akeys,n,size,compare,l,Z);
   }

   if ((r-Z  ) < RQSSZE ) {
            if ((r-Z) >1) {
               pi=&keys[(Z+1)*size];
               for(J=1;J<(r-Z);J++){
                 MEMCPY(split,(pi+J*size),size);
                 I=J-1;pj=pi+I*size;
                 while ((I>=0) && (compare(pj,split)>0) ) {
                  MEMCPY((pj+size),(pj),size);
                  I--;pj-=size;
                 }
                 MEMCPY((pj+size),split,size);
            }
           }
    }
    else {
           q6carh2a (akeys,n,size,compare,Z+1,r);
    }

}

void q6carh2(void *keys, int n, int size, int (*compare) (const void*,const void *))
{
  if (n <= 1) return ;
  q6carh2a (keys,n,size,compare,0,n-1);
}

 /* Subtle changes in else of (i<j) plus inline insertion sort BUG FIXES.... */

void q6carh3a(void *akeys, int n, int size, int (*compare) (const void*,const void*), int l, int r)
{
  register int M;
  register char *SRC, *DES;
  register char *keys = (char*) akeys;
  register int  i, j,c;
  register char *split, *pl,*pr,*pi,*pj;
  register int I,J,Z;
  /* register char *tmp; */
 if (l>=r) return;

 keys = (char *) akeys;
 /* tmp  = (char *) malloc(size*sizeof(char)); */
 split= (char *) malloc(size*sizeof(char));

#if SPLITTER == MIDDLE_KEY
 MEMCPY(split,&keys[((l+r)>>1)*size],size);
#elif SPLITTER == FIRST_KEY
 MEMCPY(split,&keys[l*size],size);
#elif SPLITTER == RANDOM_KEY
 MEMCPY(split,&keys[(l+GRANDOM((r-l+1)))*size],size);
#endif
 i=l-1           ; j=r+1;
 pl= keys+i*size ; pr= keys+j*size ;

 while (1) {
   do {j--; pr -=size;}
   while (compare(pr,split) > 0) ;
   do {i++; pl +=size; }
   while (compare(pl,split) < 0) ;
   if (i<j)  {
   /* MEMCPY(tmp,pl,size); MEMCPY(pl,pr,size); MEMCPY(pr,tmp,size); */
          M=size;
          do {
            c= *pl; *pl++ = *pr ; *pr++=c;
            } while (--M);
                pl-=size;pr-=size;
   }
   else  {     
     MEMCPY(&keys[l*size],&keys[j*size],size);
     MEMCPY(&keys[j*size],split,size);
     break;
   }


 }
   Z=j;
   if ((Z-l) < RQSSZE ) {
            if ((Z-l) >1) {   /* Subtle changes */
               pi=&keys[l*size];
               for(J=1;J<(Z-l);J++){
                 MEMCPY(split,(pi+J*size),size);
                 I=J-1;pj=pi+I*size;
                 while ((I>=0) && (compare(pj,split)>0) ) {
                  MEMCPY((pj+size),(pj),size);
                  I--;pj-=size;
                 }
                 MEMCPY((pj+size),split,size);
            }

           }

   }
   else {
           q6carh3a (akeys,n,size,compare,l,Z-1);
   }

   if ((r-Z  ) < RQSSZE ) {
            if ((r-Z) >1) {
               pi=&keys[(Z+1)*size];
               for(J=1;J<(r-Z);J++){
                 MEMCPY(split,(pi+J*size),size);
                 I=J-1;pj=pi+I*size;
                 while ((I>=0) && (compare(pj,split)>0) ) {
                  MEMCPY((pj+size),(pj),size);
                  I--;pj-=size;
                 }
                 MEMCPY((pj+size),split,size);
            }
           }
    }
    else {
           q6carh3a (akeys,n,size,compare,Z+1,r);
    }

}

void q6carh3(void *keys, int n, int size, int (*compare) (const void*,const void *))
{
  if (n <= 1) return ;
  q6carh3a (keys,n,size,compare,0,n-1);
}


