/**** 2019 (c)  All rights reserved: see agcopy19.txt ****/

#include "agssrt.h"
#ifndef MEMCPY
#define MEMCPY(X,Y,SIZE)  memcpy((X),(Y),(SIZE))
#endif

 /* QuickSort CLRS version  baseline simplest version */

void q6clrs1a (void *akeys, int   n,int size,int (*compare)(const void*,const void*),int l,int r)
{
  register int  i,j;
  register char *x,*pi,*pj,*pm,*pl,*pr;
  register char *keys=(char*)akeys;

  if (n <= 1) return ;
  x = (char *) malloc(size*sizeof(char));
  pl= keys+l*size;
  pr= keys+r*size;
  pm= &keys[((l+r)/2)*size];
  memcpy(x,pm,size);
  memcpy(pm,pr,size);
  memcpy(pr,x,size);
  i=l-1; pi=pl-size;
  j=l  ; pj=pl;
  for(j=l;j<r;++j,pj+=size) {
    if (compare(pj,pr) <=0) {
       ++i;pi+=size;
       memcpy(x ,pj,size);
       memcpy(pj,pi,size);
       memcpy(pi,x ,size);

    }
  }
  pi+=size;
  ++i;
  memcpy(x ,pr,size);
  memcpy(pr,pi,size);
  memcpy(pi,x ,size);

  if ((i-l) < RQSSZE )
     RQSIS(&keys[l*size],(i-l),size,compare);
  else
     q6clrs1a (keys,n,size,compare,l,i-1);
  if ((r-i) < RQSSZE )
     RQSIS(&keys[(i+1)*size],(r-i),size,compare);
   else
     q6clrs1a (keys,n,size,compare,i+1,r);

 free((void *)x);
}

void q6clrs1 (void *keys, int n, int size, int (*compare) (const void*,const void *))
{
  if (n <= 1) return ;
  q6clrs1a (keys,n,size,compare,0,n-1);
}


 /* QuickSort CLRS version  baseline more optimized version */

void q6clrs2a (void *akeys, int   n,int size,int (*compare)(const void*,const void*),int l,int r)
{
  register int M;
  register char *SRC, *DES;
  register char *keys=(char*)akeys;
  register int  i,j;
  register char *tmp,*pi,*pj,*pm,*pl,*pr;

  if (n <= 1) return ;
  tmp = (char *) malloc(size*sizeof(char));
#if SPLITTER == MIDDLE_KEY
  pm = &keys[((l+r)>>1)*size];
#elif SPLITTER == FIRST_KEY
  pm = &keys[l*size];
#elif SPLITTER == RANDOM_KEY
  pm = &keys[(l+GRANDOM((r-l+1)))*size];
#endif
  pl= keys+l*size; pr= keys+r*size;
  MEMCPY(tmp,pm,size); MEMCPY(pm,pr,size); MEMCPY(pr,tmp,size);
  i=l-1; pi=pl-size; j=l  ; pj=pl;
  for(j=l;j<r;j++,pj+=size) {
    if (compare(pj,pr) <=0) {
       i++;pi+=size;
       MEMCPY(tmp,pj,size);
       MEMCPY(pj,pi,size);
       MEMCPY(pi,tmp,size);
    }
  }
  pi+=size;
  i++;
  MEMCPY(tmp,pr,size);
  MEMCPY(pr,pi,size);
  MEMCPY(pi,tmp,size);

  if ((i-l) < RQSSZE )
     RQSIS(&keys[l*size],(i-l),size,compare);
  else
     q6clrs2a(&keys[l*size],i-l,size,compare,0,i-l-1);
  if ((r-i) < THRES16)
     RQSIS(&keys[(i+1)*size],(r-i),size,compare);
   else
     q6clrs2a(&keys[(i+1)*size],r-i,size,compare,0,r-i-1);

 free((void *)tmp);
}

void q6clrs2(void *keys, int n, int size, int (*compare) (const void*,const void *))
{
  if (n <= 1) return ;
#if SPLITTER == RANDOM_KEY
 GSRANDOM();
#endif
  q6clrs2a(keys,n,size,compare,0,n-1);
}

 /* QuickSort CLRS version  baseline more optimized version */

void q6clrs3a (void *akeys, int   n,int size,int (*compare)(const void*,const void*),int l,int r)
{
  register int M;
  register char *SRC, *DES;
  register char *keys=(char*)akeys, *tmp,*split;
  register int  i,j,c,I,J;
  register char *pi,*pj,*pm,*pl,*pr;

  if (n <= 1) return ;
  tmp = (char *) malloc(size*sizeof(char));
  split=(char *) malloc(size*sizeof(char));
#if SPLITTER == MIDDLE_KEY
  pm = &keys[((l+r)>>1)*size];
#elif SPLITTER == FIRST_KEY
  pm = &keys[l*size];
#elif SPLITTER == RANDOM_KEY
  pm = &keys[(l+GRANDOM((r-l+1)))*size];
#endif
  pr= keys+r*size; pl= keys+l*size;
  MEMCPY(split,pm,size); MEMCPY(pm,pr,size); MEMCPY(pr,split,size);
  i=l-1; pi=pl-size; j=l  ; pj=pl;
  for(j=l;j<r;j++,pj+=size) {
     if (compare(pj,split) <=0) {
        i++;pi+=size;
        /* MEMCPY(tmp,pj,size); MEMCPY(pj,pi,size); MEMCPY(pi,tmp,size); */
        M=size;
        do {
            c= *pi; *pi++ = *pj ; *pj++=c;
        } while (--M);
        pi-=size;pj-=size;
     }
   }
  i++;
  MEMCPY(tmp,keys+r*size,size);
  MEMCPY(keys+r*size,keys+i*size,size);
  MEMCPY(keys+i*size,tmp,size);

  if ((i-l) < RQSSZE ) {
/*
     RQSIS(&keys[l*size],(i-l),size,compare);
*/
     if ((i-l) >1) {
       pi=&keys[l*size];
       for(J=1;J<(i-l  );J++){
         MEMCPY(split,(pi+J*size),size);
         I=J-1;pj=pi+I*size;
         while ((I>=0) && (compare(pj,split)>0) ) {
          MEMCPY((pj+size),(pj),size);
          I--;pj-=size;
         }
         MEMCPY((pj+size),split,size);
       }
     }
  }
  else {
     q6clrs3a(&keys[l*size],i-l,size,compare,0,i-l-1);
  }
  if ((r-i) < RQSSZE ) {
/*
     RQSIS(&keys[(i+1)*size],(r-i),size,compare);
*/
      if ((r-i) >1) {
         pi=&keys[(i+1)*size];
         for(J=1;J<(r-i  );J++){
            MEMCPY(split,(pi+J*size),size);
            I=J-1;pj=pi+I*size;
            while ((I>=0) && (compare(pj,split)>0) ) {
               MEMCPY((pj+size),(pj),size);
               I--;pj-=size;
             }
             MEMCPY((pj+size),split,size);
         }
      }
  }
   else {
     q6clrs3a(&keys[(i+1)*size],r-i,size,compare,0,r-i-1);
   }

 free((void *)tmp); free((void*)split);
}

void q6clrs3(void *keys, int n, int size, int (*compare) (const void*,const void *))
{
  if (n <= 1) return ;
#if SPLITTER == RANDOM_KEY
 GSRANDOM();
#endif
  q6clrs3a(keys,n,size,compare,0,n-1);
}


 /* QuickSort CLRS version  baseline more optimized version */

void q6clrs4a (void *akeys, int   n,int size,int (*compare)(const void*,const void*),int *L, int *R)
{
  register int M;
  register char *SRC, *DES;
  register char *keys=(char*)akeys, *tmp,*split;
  register int  i,j,l,r,c,q,I,J;
  register char *pi,*pj,*pm,*pl,*pr;

  if (n <= 1) return ;
  tmp = (char *) malloc(size*sizeof(char));
  split=(char *) malloc(size*sizeof(char));

  l=*L;  r=*R;
while (l < r ) {
#if SPLITTER == MIDDLE_KEY
  pm = &keys[((l+r)>>1)*size];
#elif SPLITTER == FIRST_KEY
  pm = &keys[l*size];
#elif SPLITTER == RANDOM_KEY
  pm = &keys[(l+GRANDOM((r-l+1)))*size];
#endif
  pr= keys+r*size; pl= keys+l*size;
  MEMCPY(split,pm,size); MEMCPY(pm,pr,size); MEMCPY(pr,split,size);
  i=l-1; pi=pl-size; j=l  ; pj=pl;
  for(j=l;j<r;j++,pj+=size) {
     if (compare(pj,split) <=0) {
        i++;pi+=size;
        /* MEMCPY(tmp,pj,size); MEMCPY(pj,pi,size); MEMCPY(pi,tmp,size); */
        M=size;
        do {
            c= *pi; *pi++ = *pj ; *pj++=c;
        } while (--M);
        pi-=size;pj-=size;
     }
   }
  i++;
  MEMCPY(tmp,keys+r*size,size);
  MEMCPY(keys+r*size,keys+i*size,size);
  MEMCPY(keys+i*size,tmp,size);
  q=i;

  if ((q-l) < (r-q)  ) {  /* Question or Bug: is left set q-l as it currently*/
/* RQSIS(&keys[l*size],(i-l),size,compare); */
     if ((q-l) < RQSSZE ) {
       if ((q-l) >1 ) {
          pi=&keys[l*size];
          for(J=1;J<(q-l  );J++){
            MEMCPY(split,(pi+J*size),size);
            I=J-1;pj=pi+I*size;
            while ((I>=0) && (compare(pj,split)>0) ) {
             MEMCPY((pj+size),(pj),size);
             I--;pj-=size;
            }
            MEMCPY((pj+size),split,size);
          }
        }
        l=q+1;
     }
     else {
       *L=l; *R=q-1;  /* q-1 --> q , q-l ---> q-l+1 if Question above is valid  */
       q6clrs4a(keys,q-l,size,compare,L,R);
       l=q+1; /* no change */
     }
  }
  else {
  if ((r-q) < RQSSZE ) {
/*
     RQSIS(&keys[(i+1)*size],(r-i),size,compare);
*/
      if ((r-q) >1) {
         pi=&keys[(q+1)*size];
         for(J=1;J<(r-q  );J++){
            MEMCPY(split,(pi+J*size),size);
            I=J-1;pj=pi+I*size;
            while ((I>=0) && (compare(pj,split)>0) ) {
               MEMCPY((pj+size),(pj),size);
               I--;pj-=size;
             }
             MEMCPY((pj+size),split,size);
         }
      }
   r=q-1;
  }
   else {
     *L=q+1; *R=r; 
     q6clrs4a(keys,r-q,size,compare,L,R);
     r=q-1;
   }
 }

 }
 free((void *)tmp); free((void*)split);
}

void q6clrs4(void *keys, int n, int size, int (*compare) (const void*,const void *))
{
  int myL, myR;
  if (n <= 1) return ;
#if SPLITTER == RANDOM_KEY
 GSRANDOM();
#endif
   myL=0; myR=n-1;
  q6clrs4a(keys,n,size,compare,&myL,&myR);
}

