/****(c) 2020. A. Gerbessiotis. See ../KAagcopy.txt ****/
/*******************************************************/
#include "agsmrg.h"


void g8mw2 (void *x1, void *x2, int n1, int n2, int size, 
            int (*cmp)(const void *,const void *))
{
 register int i,j,l;
 register char *temp;
 register char *s1=(char*) x1,*s2=(char *)x2;
 register int M;
 register char *SRC, *DES;

 if ((n1<=0)&&(n2<=0)) return;
 temp = (char *) malloc((n1+n2)*size);
 i=j=l=0;
  while ((i<n1)&&(j<n2)){
    if (cmp(s2+j*size, s1+i*size) < 0){
      MEMCPY(temp+l*size,s2+j*size,size);
      ++j;++l;
    }
    else{
      MEMCPY(temp+l*size,s1+i*size,size);
      ++i;++l;
    }
  }
  if (i < n1) MEMCPY(temp+l*size,s1+i*size,(n1-i)*size);
  if (j < n2) MEMCPY(temp+l*size,s2+j*size,(n2-j)*size);
  MEMCPY(s1,temp,n1*size);
  MEMCPY(s2,temp+n1*size,n2*size);
  free((void *)temp);
}

void g8mw3o(void *x1, void *x2, int n1, int n2, int size, 
            int (*cmp)(const void *,const void *))
{
 register int i,j,l;
 register char *temp;
 register int ip,lp,jp;
 register char *s1=(char*) x1,*s2=(char*) x2;
 register int M;
 register char *SRC, *DES;

 if ((n1<=0)&&(n2<=0)) return;
 temp = (char *) malloc((n1+n2)*size);
 i=j=l=0;ip=jp=lp=0;
  while ((i < n1) && (j < n2)) {
    if (cmp((s2+jp),(s1+ip)) < 0) {
      MEMCPY((temp+lp),(s2+jp),size);
      ++j;++l;jp+=size;lp+=size;
    }
    else {
      MEMCPY((temp+lp),(s1+ip),size);
      ++i;++l;ip+=size;lp+=size;
    }
  }
  if (i < n1) MEMCPY((temp+lp),(s1+ip),(n1-i)*size);
  if (j < n2) MEMCPY((temp+lp),(s2+jp),(n2-j)*size);
  MEMCPY(s1,temp,n1*size);
  MEMCPY(s2,temp+n1*size,n2*size);
  free((void *)temp);
}



void g8mw4 (void *x1, void *x2, int n1, int n2, int size, 
            int (*cmp)(const void *,const void *))
{
 register int i,j;
 register char *tmp, *temp;
 register char *s1=(char*) x1,*s2=(char*) x2;
 register int M;
 register char *SRC, *DES;

 if ((n1<=0)&&(n2<=0)) return;
 tmp = (char *) malloc((n1+n2)*size);
 temp=tmp;
 i=j=0;
  while ((i < n1) && (j < n2)) {
    if (cmp(s2,s1) < 0) {
      MEMCPY(tmp,s2,size);
      ++j;s2+=size;tmp+=size;
    }
    else {
      MEMCPY(tmp,s1,size);
      ++i;s1+=size;tmp+=size;
    }
  }

  if (i < n1)  MEMCPY(tmp,s1,(n1-i)*size);
  if (j < n2)  MEMCPY(tmp,s2,(n2-j)*size); 

  MEMCPY(x1,temp,n1*size);
  MEMCPY(x2,temp+n1*size,n2*size);

  free((void *)temp);
}
