/****(c) 2021. A. Gerbessiotis. See ../KAagcopy.txt ****/
/*******************************************************/


#include <memory.h>
#include <limits.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include "agddata.h"

#ifndef MIN
#define MIN(x,y)  ((x)<=(y)?(x):(y))
#endif

#define GRANDOM(X)  (int)((random()/((double)2147483647.0))*X)
#define GSRANDOM()   srandom((unsigned int)time(NULL))

/* 2021 code definitions start here */
        /* BG:BaselinGenericSorting in MRG: MergeSort; D:Data I:Int */
        /* g1ins2 d1ins5 d1ins5 */
#define BGMRG    g1ins2
#define BDMRG    d1ins5
#define BIMRG    d1ins5
        /* Cutoff size for InsertionSort : 16, 24 or  16, 24 */
#define SGMRG    16
#define SDMRG    48
#define SIMRG    24
        /* BG:BaselinGenericSorting in QUI: QuickSort */
        /* g1ins2 d1ins5 d1ins5 */
#define BGQUI    g1ins2
#define BDQUI    d1ins5
#define BIQUI    d1ins5
        /* Cutoff size for InsertionSort  16,32,32 */
#define SGQUI    16
#define SDQUI    48
#define SIQUI    32

#define STSZ       64
#define RANDOM_KEY 0
#define FIRST_KEY  1
#define MIDDLE_KEY 2
#define MED3_KEY   3
#define SPLITTER   MIDDLE_KEY
/* 2021 code definitions end   here */

/* SWAP can be improved upon for int */
#define   SWAP(X, Y, n){        \
             M   = n;           \
             SRC = X;           \
             DES = Y;           \
             do {               \
                CH     = *SRC;  \
                *SRC++ = *DES;  \
                *DES++ = CH;    \
             } while (--M > 0); \
          }

#define SWAPP(i1,i2) \
  {ii = size;do {k = *(i1);*(i1)++ = *(i2);*(i2)++ = k;} while(--ii);}

#define SWAPPY(XX,YY,TT,SS)\
{DES=(XX);SRC=(YY);M=(SS); do {*TT=*DES;*DES++=*SRC; *SRC++=*TT;} while (--M);}

#define MEMCPY(X,Y,S) {        \
           M    = S;           \
           SRC  = Y;           \
           DES  = X;           \
           do {                \
              *DES++=*SRC++;   \
           } while (--M);      \
        }
#define IMEMCPY(X,Y,S) {       \
           M     = S;          \
           SRC   = Y;          \
           DES   = X;          \
           do {                \
              *DES++=*SRC++;   \
           } while (--M);      \
        }


void d1ins1  (ddata   * , int );
void d1ins2  (ddata   * , int );
void d1ins3  (ddata   * , int );
void d1ins4  (ddata   * , int );
void d1ins5  (ddata   * , int );
void d1ins6  (ddata   * , int );
void d1ins7  (ddata   * , int );
void d1ins8  (ddata   * , int );
void d1ins9  (ddata   * , int );
void d1ins10 (ddata   * , int );
void d1ins11 (ddata   * , int );
void d1inb1  (ddata   * , int );

void d2bat1  (ddata   * , int );
void d2bat2  (ddata   * , int );
void d2bat3  (ddata   * , int );
void d2bat4  (ddata   * , int );



void d4mrgi0 (ddata   * , int );
void d4mrgi1 (ddata   * , int );
void d4mrgi2 (ddata   * , int );
void d3mrgiu (ddata   * , int );
void d3mrgio (ddata   * , int );

void d5hpx2  (ddata   * , int );
void d5hpx3  (ddata   * , int );
void d6carh1 (ddata   * , int );
void d6carh2 (ddata   * , int );
void d6clrs  (ddata   * , int );
void d6qkrd1 (ddata   * , int );
void d6qkrd2 (ddata   * , int );
void d6qkrd3 (ddata   * , int );
void d7qkrd1 (ddata   * , int );
void d6qkrf1 (ddata   * , int );
void d7qkrf1 (ddata   * , int );
void d6qkrw1 (ddata   * , int );
void d6qkrw3 (ddata   * , int );
void d6qkrw5 (ddata   * , int );
void d6qkrw6 (ddata   * , int );
void d7qknd1 (ddata   * , int );
void d7qknd2 (ddata   * , int );

void d9rdx4u (ddata   * , int );
void d9rdx4o (ddata   * , int );

void i0gnu   (void *,int ,int ,int (*)(const void*,const void*));
void i6qkrw1 (int    * , int );
void i4mrgit1(int    * , int );

/* ALTERNATIVES FOR INLINE MEMCPY ...*/
/*
#define MEMCPY(X,Y,SIZE)  memcpy((X),(Y),(SIZE))
#undef MEMCPY
SWAP(char *x, char *y, int    size)
{
  while(size-- > 0) {
    char tmp = *x;
    *x++ = *y;
    *y++ = tmp;
  }
}
MEMCPY(void *x, void *y, int    size)
{
  while(size-- > 0) {
    char *pbTo = (char *)x;
    char *pbFrom = (char *)y;
    *pbTo++ = *pbFrom++;
  }
}
*/
