/****(c) 2021. A. Gerbessiotis. See ../KAagcopy.txt ****/
/*******************************************************/


#include <memory.h>
#include <limits.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include "aggdata.h"

#ifndef MIN
#define MIN(x,y)  ((x)<=(y)?(x):(y))
#endif

#define GRANDOM(X)  (int)((random()/((double)2147483647.0))*X)
#define GSRANDOM()   srandom((unsigned int)time(NULL))

/* 2021 code definitions start here */
        /* BG:BaselinGenericSorting in MRG: MergeSort; D:Data I:Int */
#define BGMRG    g1ins2
#define BDMRG    d1ins5
#define BIMRG    d1ins5
        /* Cutoff size for InsertionSort */
#define SGMRG    16
#define SDMRG    24
#define SIMRG    24
        /* BG:BaselinGenericSorting in QUI: QuickSort */
#define BGQUI    g1ins2
#define BDQUI    d1ins5
#define BIQUI    d1ins5
        /* Cutoff size for InsertionSort */
#define SGQUI    16
#define SDQUI    32
#define SIQUI    32

#define STSZ       64
#define RANDOM_KEY 0
#define FIRST_KEY  1
#define MIDDLE_KEY 2
#define MED3_KEY   3
#define SPLITTER   MIDDLE_KEY
/* 2021 code definitions end   here */

/* SWAP can be improved upon for int */
#define   SWAP(X, Y, n){        \
             M   = n;           \
             SRC = X;           \
             DES = Y;           \
             do {               \
                CH     = *SRC;  \
                *SRC++ = *DES;  \
                *DES++ = CH;    \
             } while (--M > 0); \
          }
#define SWAPP(i1,i2) \
  {ii = size;do {k = *(i1);*(i1)++ = *(i2);*(i2)++ = k;} while(--ii);}
#define SWAPPY(XX,YY,TT,SS) {DES=(XX);SRC=(YY);M=(SS); do {*TT=*DES;*DES++=*SRC;*SRC++=*TT;} while ( --M); }

#define MEMCPY(X,Y,S) {        \
           M    = S;           \
           SRC  = Y;           \
           DES  = X;           \
           do {                \
              *DES++=*SRC++;   \
           } while (--M);      \
        }
#define IMEMCPY(X,Y,S) {       \
           M     = S;          \
           SRC   = Y;          \
           DES   = X;          \
           do {                \
              *DES++=*SRC++;   \
           } while (--M);      \
        }


void g0gnu1  (void *,int ,int ,int (*)(const void*,const void*));

void g1ins1 (void *,int ,int ,int (*)(const void*,const void*));
void g1ins2  (void *,int ,int ,int (*)(const void*,const void*));
void g1inb1  (void *,int ,int ,int (*)(const void*,const void*));
void g2bub1  (void *,int ,int ,int (*)(const void*,const void*));
void g2bub2  (void *,int ,int ,int (*)(const void*,const void*));
void g2bub3  (void *,int ,int ,int (*)(const void*,const void*));
void g2oets  (void *,int ,int ,int (*)(const void*,const void*));

void g3mrgiu (void *,int ,int ,int (*)(const void*,const void*));
void g3mrgio (void *,int ,int ,int (*)(const void*,const void*));

void g5hpx1  (void *,int ,int ,int (*)(const void*,const void*));
void g5hpx2  (void *,int ,int ,int (*)(const void*,const void*));
void g5hpx3  (void *,int ,int ,int (*)(const void*,const void*));

void g6carh1 (void *,int ,int ,int (*)(const void*,const void*));
void g6carh2 (void *,int ,int ,int (*)(const void*,const void*));
void g6carh3 (void *,int ,int ,int (*)(const void*,const void*));

void g6qkrd1 (void *,int ,int ,int (*)(const void*,const void*));
void g6qkrd2 (void *,int ,int ,int (*)(const void*,const void*));

void g6qkrw1 (void *,int ,int ,int (*)(const void*,const void*));
void g6qkrw2 (void *,int ,int ,int (*)(const void*,const void*));
void g6qkrw3 (void *,int ,int ,int (*)(const void*,const void*));
void g6qkrw4 (void *,int ,int ,int (*)(const void*,const void*));
void g6qkrw5 (void *,int ,int ,int (*)(const void*,const void*));
void g7qkrw1 (void *,int ,int ,int (*)(const void*,const void*));
void g7qkrw2 (void *,int ,int ,int (*)(const void*,const void*));
void g7qkrw3 (void *,int ,int ,int (*)(const void*,const void*));

void g7qknd0 (void *,int ,int ,int (*)(const void*,const void*));
void g7qknd1 (void *,int ,int ,int (*)(const void*,const void*));
void g7qknd2 (void *,int ,int ,int (*)(const void*,const void*));
void g7qknd3 (void *,int ,int ,int (*)(const void*,const void*));
void g7qknd4 (void *,int ,int ,int (*)(const void*,const void*));
void g7qknd5 (void *,int ,int ,int (*)(const void*,const void*));
void g7qknd6 (void *,int ,int ,int (*)(const void*,const void*));
void g7qknd7 (void *,int ,int ,int (*)(const void*,const void*));


/* ALTERNATIVES FOR INLINE MEMCPY ...*/
/*
#define MEMCPY(X,Y,SIZE)  memcpy((X),(Y),(SIZE))
#undef MEMCPY
SWAP(char *x, char *y, int    size)
{
  while(size-- > 0) {
    char tmp = *x;
    *x++ = *y;
    *y++ = tmp;
  }
}
MEMCPY(void *x, void *y, int    size)
{
  while(size-- > 0) {
    char *pbTo = (char *)x;
    char *pbFrom = (char *)y;
    *pbTo++ = *pbFrom++;
  }
}
#endif
*/
