/****(c) 2020-2021. A. Gerbessiotis. See ../KAagcopy.txt ****/
/************************************************************/
#include "agdssrt.h"
#include <math.h>
#define  ISWAP(F,S,T) { T=F; F=S; S=T;}

void d1ins1(ddata *src,int n)
{   /* j=i-1 */
  register int i,j;
  register ddata k;
  if (n<=1) return;
  for(i=1;i<n;++i){
     k=src[i]; j=i-1; 
     while((j>=0)&&(src[j]>k)){
        src[j+1]=src[j];
        --j ; 
     }
     src[j+1]=k;
  }
}
void d1ins2(ddata *src,int n)
{   /* j=i */
  register int i,j;
  register ddata k;
  if (n<=1) return;
  for(i=1;i<n;++i){
     k=src[i]; j=i; 
     while((j> 0)&&(src[j-1]>k)){
        src[j]=src[j-1];
        --j ; 
     }
     src[j]=k;
  }
}
void d1ins3(ddata *src,int n)
{   /* j=i-1 , p */
  register int i,j;
  register ddata *p,k;
  if (n <= 1) return;
  for(i=1;i<n;++i) {
     k=src[i]; j=i-1;  p = src+j;
     while ( (j >= 0 ) && (*p > k )) {
        *(p+1)= *p;
        --j; --p;
     }
     *(p+1)=k;
  }
}
void d1ins4(ddata *src,int n)
{   /* j=i , p */
  register int i,j;
  register ddata *p,k;
  if (n <= 1) return;
  for(i=1;i<n;++i) {
     k=src[i]; j=i;  p = src+(j-1);
     while ( (j >  0 ) && (*p > k )) {
        *(p+1)= *p;
        --j; --p;
     }
     *(p+1)=k;
  }
}
void d1ins5(ddata *src,int n)  /* d1ins21 or  i21ins seqo.c */
{   /* j=i-1 , p, ip equiv to g1ins1 */
  register ddata *p,*ip,k;
  if (n <= 1) return;
  for(ip=src+1;ip<(src+n);++ip) {
     k=*ip; p=ip-1;
     while ( (p>=src) && (*p>k)) { 
        *(p+1)= *p;
         --p;
     }
     *(p+1)=k;
  }
}
void d1ins6(ddata *src,int n)
{   /* j=i-1 , p, ip  dins2 opt*/
  register ddata *p,*ip,k;
  if (n <= 1) return;
  for(ip=src+1;ip<(src+n);++ip) {
     k=*ip; p=ip;
     while ( ( p >  src ) && (*(p-1) > k )) {  
        *(p)= *(p-1); --p;
     }
     *(p)=k;
  }
}
void d1ins7(ddata *src,int n)  /* i22ins of seqo.c */
{
  register ddata *p,*ip,k;

  if (n <= 1) return;
  for(ip=src+1;ip<(src+n);++ip) {
     k=*ip;
     for( p = ip ; ( p > src) && (*(p-1) > k) ; --p){
        *p= *(p-1);
     }
     *p=k;
  }
}

void d1ins8(ddata *src, int n)  /* d1ins5 */
{
 register ddata *p, *ip,k;
 register int i;
 if (n <=1) return;
  for(i=n-1;i>0;i--)
    if (src[i]<src[i-1]) ISWAP(src[i-1],src[i],k);
 for(ip=src+1;ip<(src+n);++ip) {
   k=*ip; p=ip-1;
   while ( (p>=src) && (*p>k)) {
     *(p+1) = *p;
     --p;
   }
   *(p+1)=k;
 }
}
void d1ins9(ddata *src,int n)
{   /* j=i-1 , p, ip */
  register ddata *p,*ip,k;
  register int i;

  if (n <= 1) return;
  for (i = n-1; i > 0; i--)
    if (src[i]<src[i-1]) ISWAP(src[i-1],src[i],k);
  for(ip=src+1;ip<(src+n);++ip) {
     k=*ip;
     p=ip;
     while ( ( p >  src ) && (*(p-1) > k )) {
        *(p)= *(p-1);
         --p;
     }
     *(p)=k;
  }
}
void d1ins10(ddata *src,int n)  /* i22ins of seqo.c */
{
  register ddata *p,*ip,k;
  register int i;
  if (n <= 1) return;
  for (i = n-1; i > 0; i--)
    if (src[i]<src[i-1]) ISWAP(src[i-1],src[i],k);
  for(ip=src+1;ip<(src+n);++ip) {
     k=*ip;
     for( p = ip ; ( p > src) && (*(p-1) > k) ; --p){
        *p= *(p-1);
     }
     *p=k;
  }
}

void d1ins11(ddata *src,int n)  /* d1ins7,5 with prebubble*/
{   /* j=i-1 , p, ip equiv to g1ins1 */
  register ddata *p,*ip,k;
  register int i;
  if (n <= 1) return;
  for(i=n-1;i>0;i--)
    if (src[i]<src[i-1]) ISWAP(src[i-1],src[i],k);
  for(ip=src+1;ip<(src+n);++ip) {
     k=*ip; 
     for( p = ip-1 ; ( p >=src) && (*p > k) ; --p){
        *(p+1)= *p;
     }
     *(p+1)=k;
  }
}

/* BinarySearch Insertion Sort */

void d1inb1(ddata *src, int n)
{
 register ddata  k,*keys=src;
 register int i,j,l,r,m;

 if (n<=1) return;

 for(i=1;i<n;++i) {
    k= *(keys+i); 
    l=0;r=i-1;
    while (l <= r) {
       m = (l+r)/2;
       if (k < *(keys+m)) /* &keys[m*size] */
          r=m-1;
       else
          l=m+1;
    }

 for(j=i-1;j>=l;j--)
    *(keys+j+1) = *(keys+j);
 *(keys+l) = k;
 }
}
