/****(c) 2020-2021. A. Gerbessiotis. See ../KAagcopy.txt ****/
/************************************************************/
#include "agdssrt.h"
 /* Iterative MergeSort with baseline InsertionSort */


void d4mrgi1(ddata   *keys,int n)
{
 register int M;
 register ddata *SRC, *DES;
 register ddata *ktmp;
 register ddata   *S, *D, *T, *kys;
 register int i, j, k, r, t, LB, RB;

 if (n <  2   ) return;
 kys  = keys ;
 ktmp = (ddata   *) malloc(n*sizeof(ddata  ));

 for(t=0; t < n ; t+=SDMRG) {
    BDMRG(kys + t, MIN(SDMRG, (n-t)));
 }

 S=kys; D=ktmp;
 for(r= SDMRG   ; r < n ; r = (r+r )) {
     for(t=0 ; t < n; t += (r+r )) {
        LB=MIN(t+r, n); RB=MIN(t+(r<<1), n);
        i = t ; j = LB ; k = t;
        while ((i< LB) && (j< RB)) {
           if (S[j] < S[i]) {
              D[k] = S[j];
              ++j; ++k;
           }
           else {
              D[k] = S[i];
              ++i;++k;
           }
         }

         if (i< LB) IMEMCPY((ddata*)(D+k), (ddata*)(S+i), (LB-i));
         if (j< RB) IMEMCPY((ddata*)(D+k), (ddata*)(S+j), (RB-j));
      }
      T=S; S=D; D=T;
 }

  if (S!=kys) IMEMCPY((ddata*)kys,(ddata*)S,n );
  free(ktmp);
}

void d4mrgi2(ddata   *keys,int n)
{
 register int M;
 register ddata *SRC, *DES;
 register ddata     *ktmp;
 register ddata   *S, *D, *T, *kys, key;
 register int i, j, k, r, t, LB, RB;

 if (n <  2   ) return;
 kys  = keys ;
 ktmp = (ddata   *) malloc(n*sizeof(ddata  ));

 for(t=0; t < n ; t+=SDMRG  ) {
   /*
    BDMRG   (kys + t, MIN(SDMRG  , (n-t)));
    */
   S=kys+t;
   for(D=S+1; D< S+MIN(SDMRG  , (n-t)); ++D) {
     key=*D;SRC=D;
     while ( (SRC > S) && ( *(SRC-1) > key)) {
         *SRC=*(SRC-1); --SRC;
     }
     *SRC = key;
   }
/*
   for(D=S+1; D< S+MIN(SDMRG  , (n-t)); ++D) {
     key=*D;
     for(SRC=D; (SRC > S) && ( *(SRC-1) > key) ; --SRC) {
         *SRC=*(SRC-1);
     }
     *SRC = key;
   }
*/
 }

 S=kys; D=ktmp;
 for(r= SDMRG   ; r < n ; r = (r+r )) {
     for(t=0 ; t < n; t += (r+r )) {
        LB=MIN(t+r, n); RB=MIN(t+(r<<1), n);
        i = t ; j = LB ; k = t;
        while ((i< LB) && (j< RB)) {
           if (S[j] < S[i]) {
              D[k] = S[j];
              ++j; ++k;
           }
           else {
              D[k] = S[i];
              ++i;++k;
           }
         }

         if (i< LB) IMEMCPY((ddata*)(D+k), (ddata*)(S+i),(LB-i));
         if (j< RB) IMEMCPY((ddata*)(D+k), (ddata*)(S+j),(RB-j));
      }
      T=S; S=D; D=T;
 }

  if (S!=kys) IMEMCPY((ddata*)kys,(ddata*)S,n               );
  free(ktmp);
}

void d3mrgiu (ddata *akeys,int n)
{
  register int M;
  register ddata *DES,*SRC;
  register ddata *keys= akeys;
  register ddata *temp,*t,*s,*d;
  register int  i,j,k,ii,jj,a,b;

  if (n<=1) return;
  temp=(ddata*)malloc(n*sizeof(ddata));

  a=n/SDMRG  ;b=SDMRG  ;
  for(j=0;j<a;j++,keys+=b) {
       BDMRG(keys,SDMRG  );
  }
  if (a*SDMRG   < n)
       BDMRG(keys,n-a*SDMRG  );

  keys=akeys; /* recover original keys */

  s=keys;d=temp;
  for(a=SDMRG  ;a<n;a=(a+a)) {
     for(b=0;b<n;b+=(a+a)) {
         jj=MIN((b+(a+a)),n);ii=MIN((b+a),n);
         j=ii;i=b;k=b;
         while ((i<ii)&&(j<jj)) {
           if (*(s+j) < *(s+i)) {
              *(d+k)=*(s+j);
              ++j; ++k;
           }
           else {
              *(d+k)= *(s+i);
              ++i; ++k;
           }
         }
         if (i<ii) IMEMCPY((d+k),(s+i),(ii-i));
         if (j<jj) IMEMCPY((d+k),(s+j),(jj-j));
     }
     t=s;s=d;d=t;
  }

  if (s!=keys) IMEMCPY(keys,s,(n));
  free((void *)temp);
}

void d3mrgio (ddata *akeys, int n)
{
  register int M;
  register ddata *DES,*SRC;
  register ddata *keys= (ddata *) akeys;
  register ddata *temp,*t,*s,*d,key;
  register int  i,j,k,ii,jj,a,b;

  if (n<=1) return;
  temp=(ddata *)malloc(n*sizeof(ddata));



  a=n/SDMRG  ;b=SDMRG  ;
  for(j=0;j<a;j++,keys+=b) {
      t=keys;
      for(s=t+1; s< t+SDMRG; ++s) {
        key=*s; d=s;
        while ( (  d > t) && ( *(d-1) > key)) {
            *d=*(d-1); --d;
        }
        *d=key;
      }
/*
      for(s=t+1;s<t+b; ++s){
         key  = *s ;
         for(d=s; (d > t) && ( *(d-1) > key );--d){
            *d= *(d-1);
         }
         *d = key ;
      }
*/
  }
  if (a*SDMRG   < n) {
      t=keys;
      for(s=t+1; s< t+(n-a*SDMRG); ++s) {
        key=*s; d=s;
        while ( (  d > t) && ( *(d-1) > key)) {
            *d=*(d-1); --d;
        }
        *d=key;
      }
/*
      for(s=t+1;s<t+(n-a*SDMRG  );++s){
          key = *s ;
          for(d=s;(d > t) && (*(d-1) > key);--d){
             *d= *(d-1);
          }
          *d = key;
      }
*/
  }

  keys=(ddata *) akeys; /* recover original keys */
  s=keys;d=temp;
  for(a=SDMRG  ;a<n;a=(a+a)) {
     for(b=0;b<n;b+=(a+a)) {
         jj=MIN((b+(a+a)),n); ii=MIN((b+a),n);
         j=ii; i=b; k=b; /* k=i */
         while ((i<ii)&&(j<jj)) {
           if (*(s+j) < *(s+i)) {
              *(d+k) = *(s+j);
              ++j; ++k;
           }
           else {
              *(d+k) = *(s+i);
              ++i; ++k;
           }
         }
         if (i<ii) IMEMCPY((d+k),(s+i),(ii-i));
         if (j<jj) IMEMCPY((d+k),(s+j),(jj-j));
     }
     t=s;s=d;d=t;
  }

  if (s!=keys) IMEMCPY(keys,s,n);

  free((void *)temp);
}

