/****(c) 2020-2021. A. Gerbessiotis. See ../KAagcopy.txt ****/
/************************************************************/
#include "agdssrt.h"
#ifndef MEMCPY
#define MEMCPY(X,Y,SIZE)  memcpy((X),(Y),(SIZE))
#endif

ddata *i3(ddata *a, ddata *b, ddata*c)
{
 return(  *a < *b ?
         (*b < *c ? b : (*a < *c ? c : a ) ) :
         (*b > *c ? b : (*a < *c ? a : c ) ));
}

 /* CAR Hoare sort. CLR derived */

void d61(ddata *akeys, int *L,int *R)
{
  register int  l,r,mL,mR;
  register ddata *keys=akeys;
  register ddata split, tmp,*pl,*pr,*pm;


  if ((*R-*L) <= 0) return ; 

  mL=*L;mR=*R;
  while (mL < mR ) {
     l=mL;r=mR;
#if   SPLITTER == MIDDLE_KEY
      split=keys[(l+r)>>1];
#elif SPLITTER == FIRST_KEY
      split=keys[l];
#elif SPLITTER == RANDOM_KEY
      split=keys[l+GRANDOM((r-l+1))];
#elif SPLITTER == MED3_KEY
      if (r-l>8){
        pm=i3(keys+l,keys+r,keys+((l+r)>>1));
        split=*pm;
      } else {
        split=keys[(l+r)>>1];
      }
#endif

      while (l <= r) {
         while (keys[l]<split) ++l;
         while (split< keys[r]) --r;
         if (l <= r) { 
            tmp=keys[l];
            keys[l]=keys[r];
            keys[r]=tmp;
            ++l;--r;
         }
      }
      if ((r-mL) < (mR-l)) { 
         if ((r-mL+1) < SDQUI   ) {
            if ((r-mL) >0) { 
               pm=keys+mL;
               for(pr=pm+1; pr< pm+(r-mL+1); ++pr){
                  split=*pr;
                  for(pl=pr; pl >pm && (*(pl-1)>split) ; --pl) {
                     *(pl)=*(pl-1);
                  }
                  *(pl)=split;
               }
            }
            mL=l;
         }
         else {
            *R=r; *L=mL; 
            d61(keys,L,R);
            mL=l;  
         }
      }
      else {   
         if ((mR-l+1) < SDQUI   ) {
            if ((mR-l) >0) { 
               pm=keys+l;
               for(pr=pm+1; pr< pm+(mR-l+1); ++pr){
                  split=*pr;
                  for(pl=pr; pl >pm && (*(pl-1)>split) ; --pl) {
                     *(pl)=*(pl-1);
                  }
                  *(pl)=split;
               }
            }
            mR=r;
         }
         else {
            *L=l; *R=mR;  
            d61 (keys,L,R);
            mR=r;  
         }
      } 
  }
}

void d6carh1(ddata *keys, int n)
{
  int myL,myR;
  if (n <= 1) return ;
#if SPLITTER == RANDOM_KEY
 GSRANDOM();
#endif
  myL=0;myR=n-1;
  d61 (keys,&myL,&myR);
}

void d62(ddata *akeys, int l,int r)
{
  register ddata *keys=akeys;
  register int  i,j,Z,I,J;
  register ddata split, tmp,*pl,*pr,*pm;


  if (l>=r) return;
#if   SPLITTER == MIDDLE_KEY
      split=keys[(l+r)>>1];
/*
      if (r-l>8){
        pm=i3(keys+l,keys+r,keys+((l+r)>>1));
        split=*pm;
      }
*/
#elif SPLITTER == FIRST_KEY
      split=keys[l];
#elif SPLITTER == RANDOM_KEY
      split=keys[l+GRANDOM((r-l+1))];
#elif SPLITTER == MED3_KEY
      if ((r-l)>8){
        pm=i3(keys+l,keys+r,keys+((l+r)>>1));
        split=*pm;
      } else {
        split=keys[(l+r)>>1];
      }
#endif
     i=l-1; j=r+1;
     pl=keys+i; pr=keys+j;

     while (1) {
       do { --j; --pr;}
       while (*pr > split);
       do { ++i; ++pl;}
       while (*pl < split);
       if (i < j) { 
         tmp=*pl;
         *pl=*pr;
         *pr=tmp;
/*
         --pl;--pr;    ++i;--j;
*/
       }
       else break;
     }
     Z=j;
     if ((Z-l+1) < SDQUI  ) {
            if ((Z-l) >0) {
               pl=keys+l;
               for(J=1;J<(Z-l+1);J++){
                  split=*(pl+J);
                  I=J-1;pr=pl+I;
                  while ((I>=0) && (*pr > split) ) {
                    *(pr+1)= *pr;
                    --I;--pr;
                  }
                  *(pr+1)=split;
               }
            }

     }
     else {
       d62(akeys,l,Z);
     }
     if ((r-Z  ) < SDQUI  ) {
            if ((r-Z)>1) {
               pl=keys+(Z+1);
               for(J=1;J<(r-Z);J++){
                  split=*(pl+J);
                  I=J-1;pr=pl+I;
                  while ((I>=0) && (*pr > split) ) {
                    *(pr+1)=*pr;
                    --I;--pr;
                 }
                 *(pr+1)=split;
               }
           }
    }
    else {
      d62(akeys,Z+1,r);
    }
}
void d6carh2(ddata *keys, int n)
{
  if (n  < 2) return ;
#if SPLITTER == RANDOM_KEY
 GSRANDOM();
#endif
  d62 (keys,0,n-1);
}


void d6clrs0a(ddata *keys, int n, unsigned int l, unsigned int r)
{
  register unsigned int  i,j;
  register ddata pr,pm,tmp; 

  if (n <= 1) return ;
  /* pl=keys[l]; */
  pr=keys[r];
#if SPLITTER == MIDDLE_KEY
  pm = keys[((l+r)/2 )];
#elif SPLITTER == FIRST_KEY
  pm = keys[l];
#elif SPLITTER == RANDOM_KEY
  pm = keys[(l+GRANDOM((r-l+1)))];
#endif
  tmp=pm; pm=pr; pr=tmp;
  i=l-1; j=l  ;

  for(j=l;j<r;++j) {
    if (keys[j]<=keys[r]) {
       ++i;
       tmp=*(keys+j);
       *(keys+j)=*(keys+i);
       *(keys+i)=tmp;
    }
  }
  ++i;
  tmp=*(keys+r);
  *(keys+r)=*(keys+i);
  *(keys+i)=tmp;

  if ((i-l) < SDQUI    )
     BDQUI (keys+l,(i-l));
  else
     d6clrs0a(keys+l,i-l,0,i-l-1);
  if ((r-i) < SDQUI   )
     BDQUI (keys+(i+1),(r-i));
   else
     d6clrs0a(keys+(i+1),r-i,0,r-i-1);

}

void d6clrs(ddata *keys, int n)
{
  if (n <= 1) return ;
#if SPLITTER == RANDOM_KEY
 GSRANDOM();
#endif
  d6clrs0a(keys,n,(unsigned int) 0,(unsigned int) n-1);
}
