/****(c) 2020-2021. A. Gerbessiotis. See ../KAagcopy.txt ****/
/************************************************************/
#include "agdssrt.h"
#ifndef MEMCPY
#define MEMCPY(X,Y,SIZE)  memcpy((X),(Y),(SIZE))
#endif

 /* Data QuickSort Recursive using do   */
void 
d6qkrd1a(ddata *akeys, unsigned int n, unsigned int l, unsigned int r)
{
  register unsigned int i,j;
  register ddata split,tmp, *keys=akeys;

  i=l;j=r;
#if   SPLITTER == MIDDLE_KEY
  split=keys[(l+r)/2];
#elif SPLITTER == FIRST_KEY
  split=keys[l];
#elif SPLITTER == RANDOM_KEY
  split=keys[l+GRANDOM((r-l+1))];
#endif
  do {
        while (keys[i]<split) ++i;
        while (split<keys[j]) --j;
        if (i <= j ) {
          tmp=*(keys+i);
          *(keys+i)=*(keys+j);
          *(keys+j)=tmp;
          ++i;--j;
        }
  } while (i <= j);

  if (l < j) {
    if ((j-l) < SDQUI  )
       BDQUI(keys+l,(j-l+1));
    else
       d6qkrd1a(keys,n,l,j);
  }
  if (i < r) {
    if ((r-i) < SDQUI  )
       BDQUI(keys+i,(r-i+1));
    else
      d6qkrd1a(keys,n,i,r);
  }
}

void d6qkrd1(ddata *keys, int n)
{
 if (n<=1) return;
#if SPLITTER == RANDOM_KEY
 GSRANDOM();
#endif
 d6qkrd1a(keys,(unsigned int) n,(unsigned int) 0, (unsigned int)( n-1));
}

ddata *i3(ddata*, ddata*, ddata*);

void 
d6qkrd2a(ddata *akeys, unsigned int n, unsigned int l, unsigned int r)
{
  register unsigned int i,j;
  register ddata split,tmp, *keys=akeys, *Z;

  i=l;j=r;
#if   SPLITTER == MIDDLE_KEY
  split=keys[(l+r)/2];
  if (n>8){
    Z=i3(keys+l,keys+r,keys+((l+r)>>1));
    split= *Z;
  }
#elif SPLITTER == FIRST_KEY
  split=keys[l];
#elif SPLITTER == RANDOM_KEY
  split=keys[l+GRANDOM((r-l+1))];
#endif
  do {
        while (keys[i]<split) ++i;
        while (split<keys[j]) --j;
        if (i <= j ) {
          tmp=*(keys+i);
          *(keys+i)=*(keys+j);
          *(keys+j)=tmp;
          ++i;--j;
        }
  } while (i <= j);

  if (l < j) {
    if ((j-l) < SDQUI  )
       BDQUI(keys+l,(j-l+1));
    else
       d6qkrd2a(keys,n,l,j);
  }
  if (i < r) {
    if ((r-i) < SDQUI  )
       BDQUI(keys+i,(r-i+1));
    else
      d6qkrd2a(keys,n,i,r);
  }
}

void d6qkrd2(ddata *keys, int n)
{
 if (n<=1) return;
#if SPLITTER == RANDOM_KEY
 GSRANDOM();
#endif
 d6qkrd2a(keys,(unsigned int) n,(unsigned int) 0, (unsigned int)( n-1));
}


void 
d6qkrd3a(ddata *akeys, unsigned int n, unsigned int l, unsigned int r)
{
  register unsigned int i,j;
  register ddata split,tmp, *keys=akeys, *S,*D,*SRC;

  i=l;j=r;
#if   SPLITTER == MIDDLE_KEY
  split=keys[(l+r)/2];
  if (n>8){
    S=i3(keys+l,keys+r,keys+((l+r)>>1));
    split= *S;
  }
#elif SPLITTER == FIRST_KEY
  split=keys[l];
#elif SPLITTER == RANDOM_KEY
  split=keys[l+GRANDOM((r-l+1))];
#endif
  do {
        while (keys[i]<split) ++i;
        while (split<keys[j]) --j;
        if (i <= j ) {
          tmp=*(keys+i);
          *(keys+i)=*(keys+j);
          *(keys+j)=tmp;
          ++i;--j;
        }
  } while (i <= j);

  if (l < j) {
    if ((j-l) < SDQUI  ) {
     /*  BDQUI(keys+l,(j-l+1));  */
       S=keys+l;
      for(D=S+1; D< S+(j-l+1); ++D) {
        tmp=*D;SRC=D;
        while ( (SRC > S) && ( *(SRC-1) > tmp)) {
            *SRC=*(SRC-1); --SRC;
        }
        *SRC = tmp;
      }
    }
    else
       d6qkrd3a(keys,n,l,j);
  }
  if (i < r) {
    if ((r-i) < SDQUI  ) {
     /*  BDQUI(keys+i,(r-i+1));  */
       S=keys+i;
      for(D=S+1; D< S+(r-i+1); ++D) {
        tmp=*D;SRC=D;
        while ( (SRC > S) && ( *(SRC-1) > tmp)) {
            *SRC=*(SRC-1); --SRC;
        }
        *SRC = tmp;
      }
    }
    else
      d6qkrd3a(keys,n,i,r);
  }
}

void d6qkrd3(ddata *keys, int n)
{
 if (n<=1) return;
#if SPLITTER == RANDOM_KEY
 GSRANDOM();
#endif
 d6qkrd3a(keys,(unsigned int) n,(unsigned int) 0, (unsigned int)( n-1));
}

void 
d7qkrd1a(ddata *akeys, unsigned int n, unsigned int l, unsigned int r)
{
  register unsigned int i,j;
  register ddata split,tmp, *keys=akeys, *Z;

  i=l;j=r;
#if   SPLITTER == MIDDLE_KEY
  split=keys[(l+r)/2];
  if (n>8){
    Z=i3(keys+l,keys+r,keys+((l+r)>>1));
    split= *Z;
  }
#elif SPLITTER == FIRST_KEY
  split=keys[l];
#elif SPLITTER == RANDOM_KEY
  split=keys[l+GRANDOM((r-l+1))];
#endif
  do {
        while (keys[i]<split) ++i;
        while (split<keys[j]) --j;
        if (i <= j ) {
          tmp=*(keys+i);
          *(keys+i)=*(keys+j);
          *(keys+j)=tmp;
          ++i;--j;
        }
  } while (i <= j);

  if (l < j) {
    if ((j-l) < SDQUI  )
     ;
/*
       BDQUI(keys+l,(j-l+1));
*/
    else
       d7qkrd1a(keys,n,l,j);
  }
  if (i < r) {
    if ((r-i) < SDQUI  )
      ;
/*
       BDQUI(keys+i,(r-i+1));
*/
    else
      d7qkrd1a(keys,n,i,r);
  }
}

void d7qkrd1(ddata *keys, int n)
{
 if (n<=1) return;
#if SPLITTER == RANDOM_KEY
 GSRANDOM();
#endif
 d7qkrd1a(keys,(unsigned int) n,(unsigned int) 0, (unsigned int)( n-1));
 BDQUI(keys,n);
}
