/****(c) 2020-2021. A. Gerbessiotis. See ../KAagcopy.txt ****/
/************************************************************/
#include "agdssrt.h"
#ifndef MEMCPY
#define MEMCPY(X,Y,SIZE)  memcpy((X),(Y),(SIZE))
#endif
#define  SWAPI(F,S,T) { T=F; F=S; S=T;}


 /* Data QuickSort Recursive Hoare with inline memcpy/InsrtionSort   */

void d6qkrw1a (ddata *akeys, unsigned int   n)
{
 register unsigned int i, j;
 register ddata split, tmp;
 register ddata *keys=(ddata*)akeys;

 if (n <=1) return;
 i=0;j=n-1;

#if   SPLITTER == MIDDLE_KEY
 split=keys[n/2];
#elif SPLITTER == FIRST_KEY
 split=keys[0];
#elif SPLITTER == RANDOM_KEY
 split=keys[GRANDOM(n)];
#endif

 while (i<=j) {
   while (keys[i]<split) ++i;
   while (keys[j]>split) --j;
   if (i <= j) {
     tmp=*(keys+i);
     *(keys+i)=*(keys+j);
     *(keys+j)=tmp;
/*
     tmp=keys[i];
     keys[i]=keys[j];
     keys[j]=tmp;
*/
     ++i;--j;
   }
 }

  if (j>0) {
    if ((j+1)< SDQUI   ) BDQUI(keys,j+1);
    else d6qkrw1a(keys,j+1);
  }
  if (i<n) {
    if ((n-i)< SDQUI   ) BDQUI(keys+i,n-i);
    else d6qkrw1a(keys+i,n-i);
  }
}

void d6qkrw1 (ddata *keys, int n)
{
  if (n <= 1) return ;
#if SPLITTER == RANDOM_KEY
 GSRANDOM();
#endif
  d6qkrw1a (keys,(unsigned int) n);
}

 /* Data QuickSort Recursive Hoare with inline memcpy/InsrtionSort   */
void d6qkrw5a (ddata *akeys,  int *L,int *R)
{
  register int  l,r,mL,mR;
  register ddata *keys=akeys;
  register ddata split, tmp;


  if ((*R-*L) <= 0) return ; /* if ((*R-*L+1) <= 1) return ; */

   mL=*L;mR=*R;
  while (mL < mR ) {
     l=mL;r=mR;
#if   SPLITTER == MIDDLE_KEY
 split=keys[(l+r)/2];
#elif SPLITTER == FIRST_KEY
 split=keys[l];
#elif SPLITTER == RANDOM_KEY
 split=keys[l+GRANDOM((r-l+1))];
#endif

     while (l <= r) {
         while (keys[l]<split) ++l;
         while (split< keys[r]) --r;
         if (l <= r) { /* is it ok if < ? */
           tmp=keys[l];
           keys[l]=keys[r];
           keys[r]=tmp;
/*
           tmp=*(keys+l);
           *(keys+l)=*(keys+r);
           *(keys+r)=tmp;
*/
           ++l;--r;
         }
     }

   if ((r-mL) < (mR-l)) { /* Left side smaller; eliminated a +1 from both sides */
      if ((r-mL+1) < SDQUI   ) {
         if ((r-mL) >0) {   /* usedto be r-mL+1 > 1 */
           BDQUI(&keys[mL],(r-mL+1));
         }
          mL=l;
      }
      else {
         *R=r; *L=mL; /* mL...r */
         d6qkrw5a(keys,L,R);
         mL=l;  /* OR r l ..mR */
      }
   } /*left */
  else {               /* Right side smaller */
      if ((mR-l+1) < SDQUI   ) {
        if ((mR-l) >0) { /* used to be mR-l+1 >1 */
         BDQUI(&keys[l],(mR-l+1));
        }
        mR=r;
      }
      else {
        *L=l; *R=mR;  /* l...mR */
        d6qkrw5a(keys,L,R);
        mR=r;  /* mL ...r */
      }

  } /*right*/
 }

}

void d6qkrw5 (ddata *keys, int n)
{
  int myL,myR;
  if (n <= 1) return ;
#if SPLITTER == RANDOM_KEY
 GSRANDOM();
#endif
  myL=0;myR=n-1;
  d6qkrw5a (keys,&myL,&myR);
}

void ag48qwro (ddata *akeys, int   n)
{
 register ddata split, tmp;
/*
 register ddata *pi,*pj, *pp;
 register ddata *akeys=(ddata*) keys;
*/
 register int i,j;

 if (n <= 1) return ;
 i=0; j=n-1;

#if SPLITTER == MIDDLE_KEY
  split=akeys[(n-1)/2];
#elif SPLITTER == FIRST_KEY
  split=akeys[0];
#elif SPLITTER == RANDOM_KEY
  split=akeys[GRANDOM((n-1))];
#endif
 
/*
  pi=akeys;  pj=akeys+n-1;
  i=0; j=n-1;
  while ( i <=  j) {
      while ( *pi < split)  {++pi;++i;}
      while ( split < *pj)  {--pj;--j;}
      if (i <= j) {
         tmp= *pi;
         *pi= *pj;
         *pj= tmp;
         ++pi;--pj;++i;--j;
      }
  }
*/
  while ( i <=  j) {
      while ( akeys[i] < split) ++i;
      while ( split < akeys[j]) --j;
      if (i <= j) {
         tmp= akeys[i];
         akeys[i]=akeys[j];
         akeys[j]=tmp;
         ++i;--j;
      }
  }
  
  if (j > 0) {
      if ((j+1)<SDQUI   ) {
               BDQUI(akeys,j+1);
/*
                   pi=akeys;
                   for(pj=pi+1   ;pj<pi+j+1;++pj){
		     split= *pj;
                     pp = pj-1;
                     while (( pp >= pi ) && (*pp > split)) {
                        *(pp+1)= *pp;
                        --pp;
                     }
                     *(pp+1)=split;
                     }
                   for(pj=pi+1   ;pj<pi+j+1;++pj){
		     split= *pj;
                     for(pp=pj;pp > pi &&(*(pp-1)> split); --pp){
                       *pp = *(pp-1);
                     }
                     *pp=split;
                   }
*/
      }
      else ag48qwro(akeys,j+1);
  }
  if (i < n) {
      if ((n - i)<SDQUI   ) {
                 BDQUI(akeys+i,n-i);
/*
                   pi=akeys+i;
                   for(pj=pi+1   ;pj<pi+n-i;++pj){
		     split= *pj;
                     pp = pj-1;
                     while (( pp >= pi ) && (*pp > split)) {
                        *(pp+1)= *pp;
                        --pp;
                     }
                     *(pp+1)=split;
                    }
                   for(pj=pi+1;pj< pi+(n-i);++pj){
		     split= *pj;
                     for(pp=pj;pp > pi &&(*(pp-1)> split); --pp){
                       *pp = *(pp-1);
                     }
                     *pp=split;
                   }
*/
      }
      else ag48qwro(akeys+i,n-i);
  }
}
           
void d6qkrw3 (ddata *keys, int n)
{
  if (n <= 1) return ;
#if SPLITTER == RANDOM_KEY
 GSRANDOM();
#endif
  ag48qwro(keys,n);
}



int partition(ddata *src,int l, int r)
{
  register int i = l-1, j = r;
  register ddata t,split=src[r];

  for (;;)
    {
      while (src[++i]<split);
      while (split<src[--j])
        if (j == l)
          break;
      if (i >= j)
        break;
      SWAPI(src[i], src[j],t);
    }
  SWAPI(src[i], src[r],t);
  return i;
}

void quicksort(ddata *src, int l, int r)     
{
  register int i;
  register ddata t;

  if (r-l <= SDQUI)
    return;
  SWAPI(src[(l+r)/2], src[r-1],t);
  if (src[r-1]<src[l]) SWAPI(src[l],src[r-1],t);
  if (src[r]<src[l]) SWAPI(src[l],src[r],t);
  if (src[r]<src[r-1]) SWAPI(src[r-1],src[r],t);
  i = partition(src, l+1, r-1);
  quicksort(src, l, i-1);
  quicksort(src, i+1, r);
}

void ad1insx(ddata *src,int l, int r)
{
  register int i,j;
  register ddata t;

  for (i = r; i > l; i--)
    if (src[i]<src[i-1]) SWAPI(src[i-1],src[i],t);
  for (i = l + 2; i <= r; i++) {
    j = i;
    t = src[i];
    while (t< src[j-1])
        {
          src[j] = src[j-1];
          j--;
        }
      src[j] = t;
    }
}




void d6qkrw6 (ddata *keys, int n)
{
  if (n <= 1) return ;
#if SPLITTER == RANDOM_KEY
 GSRANDOM();
#endif
  quicksort(keys,0,n-1);
  ad1insx(keys,0,n-1);
}

