/****(c) 2020-2021. A. Gerbessiotis. See ../KAagcopy.txt ****/
/************************************************************/
#include "agdssrt.h"
 /* Radix Sort                */
/* Watch out if data is signed integer type !!!!  */
void d9rdx4u(ddata *src, int n)
{
  register unsigned int   i,k;
  register          int   j;
  register ddata *des;
  unsigned int   cnt[256];
  
  if (n <= 1) return;
  des= (ddata  *) malloc(n*sizeof(ddata ));

  memset(cnt,0,256*sizeof(ddata)); 
  for(j=0;j<n;++j)   cnt[src[j] & 0x000000FF]++; 
  for(i=1;i<256;++i) cnt[i] += cnt[i-1];
  for(j=n-1;j>=0;--j) {
     k=--cnt[src[j] & 0x000000FF]; 
     des[k]=src[j];
  }

  memset(cnt,0,256*sizeof(ddata)); 
  for(j=0;j<n;++j)  cnt[(des[j] >> 8) & 0x000000FF ]++;
  for(i=1;i<256;++i) cnt[i] += cnt[i-1];
  for(j=n-1;j>=0;--j) {
     k=--cnt[(des[j] >> 8) &  0x000000FF];
     src[k]=des[j];
  }

  memset(cnt,0,256*sizeof(ddata)); 
  for(j=0;j<n;++j)  cnt[(src[j] >> 16) & 0x000000FF ]++;
  for(i=1;i<256;++i) cnt[i] += cnt[i-1];
  for(j=n-1;j>=0;--j) {
     k=--cnt[(src[j] >> 16) & 0x000000FF ];
     des[k]=src[j];
  }

  memset(cnt,0,256*sizeof(ddata)); 
  for(j=0;j<n;++j)  cnt[des[j] >> 24]++;
  for(i=1;i<256;++i) cnt[i] += cnt[i-1];
  for(j=n-1;j>=0;--j) {
     k=--cnt[des[j] >> 24];
     src[k]=des[j];
  }
  free((void *)des);
}

void d9rdx4o(ddata  *src, int n)
{
  register unsigned int  i,k;
  register ddata         *beg, *end, *jp,*des;
  unsigned int   cnt[256];
  
  if (n <= 1) return;
  des= (ddata  *) malloc(n*sizeof(ddata ));


  memset(cnt,0,256*sizeof(ddata)); 
  beg=src ;
  end=src+n;
  for(jp=beg;jp<end;++jp) (*(cnt+ (*jp & 0x000000FF)))++; 
  for(i=1;i<256;++i) cnt[i] += cnt[i-1];
  for(jp=end-1;jp>= beg ;--jp) {
     k=--*(cnt+( *jp & 0x000000FF)); 
     *(des+k)= *jp;
  }

  memset(cnt,0,256*sizeof(ddata)); 
  beg=des;
  end=des+n;
  for(jp=beg;jp<end;++jp) (*(cnt+ ((*jp>>8) & 0x000000FF)))++; 
  for(i=1;i<256;++i) cnt[i] += cnt[i-1];
  for(jp=end-1;jp>= beg ;--jp) {
     k=--*(cnt+( (*jp>>8) & 0x000000FF)); 
     *(src+k)= *jp;
  }

  memset(cnt,0,256*sizeof(ddata)); 
  beg= src ;
  end= src+n;
  for(jp=beg;jp<end;++jp) (*(cnt+ ((*jp>>16) & 0x000000FF)))++; 
  for(i=1;i<256;++i) cnt[i] += cnt[i-1];
  for(jp=end-1;jp>= beg ;--jp) {
     k=--*(cnt+( (*jp>>16) & 0x000000FF)); 
     *(des+k)= *jp;
  }

  memset(cnt,0,256*sizeof(ddata)); 
  beg=des;
  end=des+n;
  for(jp=beg;jp<end;++jp) (*(cnt+ ((*jp>>24) & 0x000000FF)))++; 
  for(i=1;i<256;++i) cnt[i] += cnt[i-1];
  for(jp=end-1;jp>= beg ;--jp) {
     k=--*(cnt+( (*jp>>24) & 0x000000FF)); 
     *(src+k)= *jp;
  }
  free((void *)des);
}
