/****(c) 2020-2021. A. Gerbessiotis. See ../KAagcopy.txt ****/
/************************************************************/
#include "aggssrt.h"

/* ins1: for-while, ins2: for-for implementation of InsSort */
/* inb1: for-while  implementation of BinaraSearchInsSort   */
void g1ins1(void *akeys, int n, int size,int(*compare)(const void*,const void*))
{
 register int  M;
 register char *SRC,*DES;
 register char *keys= (char*) akeys ;
 register char *p,*ip,*k;

 if (n <=1) return;
 k   = (char *) malloc(size*sizeof(char));
 for(ip=keys+size; ip<(keys+n*size); ip+=size) {
   MEMCPY(k,ip,size);
   p=ip-size;
   while ( (p>=keys) && ( compare(p,k)>0) ) {
     MEMCPY((p+size),(p),size);
     p-=size;
   }
   MEMCPY((p+size), k, size);
 }
 free((void *) k );
}

void g1ins2(void *akeys, int n, int size,int(*compare)(const void*,const void*))
{
 register int  M;
 register char *SRC, *DES;
 register char *keys=(char*)akeys;
 register char *p,*ip,*k;

 if (n <=1) return;
 k    = (char*) malloc(size*sizeof(char));
 for(ip=keys+size; ip < (keys+n*size) ; ip += size) {
    MEMCPY(k, ip, size);
    for(p=ip ; (p > keys ) && (compare(p-size, k) > 0 ); p-=size){
       MEMCPY(p,p-size,size);
    }
    MEMCPY(p, k, size);
 }
 free((void *) k );
}

/* BinarySearch Insertion Sort */

void g1inb1(void *akeys, int n, int size,int(*compare)(const void*,const void*))
{
 register int M;
 register char *SRC, *DES, *k;
 register char  *keys=(char*)akeys;
 register int i,j,l,r,m;

 if (n <=1) return;
 k    = (char *) malloc(size*sizeof(char));

 for(i=1;i<n;++i) {
    MEMCPY(k,keys+i*size,size); /* &keys[i*size] */
    l=0;r=i-1;
    while (l <= r) {
       m = (l+r)/2;
       if (compare(k,keys+m*size) < 0) /* &keys[m*size] */
          r=m-1;
       else
          l=m+1;
    }

 for(j=i-1;j>=l;j--)
    MEMCPY(keys+(j+1)*size,keys+j*size,size);
 MEMCPY(keys+l*size,k,size);
 }
 free((void*)k);
}
