/**(c) 2020-2021. A. Gerbessiotis. See ../KAagcopy.txt **/
/********************************************************/
#include "aggssrt.h"



void g3mrgiu(void *akeys,int n,int size,int(*compare)(const void*,const void*))
{
  register int M;
  register char *DES,*SRC;
  register char *keys= (char *) akeys;
  register char *temp,*s,*d,*t;
  register int  i,j,k,ii,jj,a,b;

  if (n<=1) return;
  temp=(char *)malloc(n*size*sizeof(char));

  a=n/SGMRG  ;b=SGMRG  *size;
  for(j=0;j<a;j++,keys+=b) {
     BGMRG(keys,SGMRG  ,size,compare);
  }
  if (a*SGMRG < n)
     BGMRG(keys,n-a*SGMRG  ,size,compare);

  keys=(char *)akeys; 

  s=keys;d=temp;
  for(a=SGMRG; a<n; a=(a+a)) {  /* (a<<1) vs (a+a) */
     for(b=0; b<n; b+=(a+a)) {
         ii=MIN((b+a),n)*size;      jj=MIN((b+(a+a)),n)*size;
         i=b*size;                  j=ii; k=i; /* was b*size */
         while ((i<ii)&&(j<jj)) {
           if (compare(s+j,s+i)<0) {
              MEMCPY((d+k),(s+j),size);
              j+=size; k+=size;
           }
           else {
              MEMCPY((d+k),(s+i),size);
              i+=size; k+=size;
           }
         }
         if (i<ii) MEMCPY((d+k),(s+i),(ii-i));    
         if (j<jj) MEMCPY((d+k),(s+j),(jj-j));
     }
     t=s;s=d;d=t;
  }

  if (s!=keys) MEMCPY(keys,s,n*size); 
  free((void *)temp);
}






  /* Optimized (inline insertion sort) version of g3mrgiu */
void g3mrgio(void *akeys,int n,int size,int(*compare)(const void*,const void*))
{
  register int M;
  register char *DES,*SRC;
  register char *keys= (char *) akeys;
  register char *temp,*s,*d,*t;
  register int  i,j,k,ii,jj,a,b;

  if (n<=1) return;
  temp=(char *)malloc(n*size*sizeof(char));

  a=n/SGMRG  ;b=SGMRG  *size;
  for(j=0;j<a;j++,keys+=b) {
      /* BGMRG   (keys,SGMRG  ,size,compare); */
      t=keys;
      for(s=t+size; s<t+b; s+=size){
        MEMCPY(temp,s,size);
        for(d=s;d > t &&(compare(d-size,temp)>0);d-=size){
          MEMCPY((d),(d-size),size);
        }
        MEMCPY((d),temp,size);
      }
  }
  if (a*SGMRG   < n) {
      /* BGMRG   (keys,n-a*SGMRG  ,size,compare); */
      t=keys;
      for(s=t+size;s<t+(n-a*SGMRG  )*size;s+=size){
        MEMCPY(temp,s,size);
        for(d=s;d > t &&(compare(d-size,temp)>0);d-=size){
          MEMCPY((d),(d-size),size);
        }
        MEMCPY((d),temp,size);
      }
  }

  keys=(char *) akeys; /* recover original keys */
  s=keys;d=temp;
  for(a=SGMRG; a<n; a=(a+a)) { 
     for(b=0; b<n; b+=(a+a)) {
         ii=MIN((b+a),n)*size; 
         jj=MIN((b+(a+a)),n)*size;
         i=b*size;
         j=ii;
         k=i;
         while ((i<ii)&&(j<jj)) {
           if (compare(s+j,s+i)<0) {
              MEMCPY((d+k),(s+j),size);
              j+=size; k+=size;
           }
           else {
              MEMCPY((d+k),(s+i),size);
              i+=size;k+=size;
           }
         }
         if (i<ii) MEMCPY((d+k),(s+i),(ii-i));    
         if (j<jj) MEMCPY((d+k),(s+j),(jj-j));
     }
     t=s;s=d;d=t;
  }

  if (s!=keys) MEMCPY(keys,s,n*size); 
  free((void *)temp);
}
