/**(c) 2020-2021. A. Gerbessiotis. See ../KAagcopy.txt **/
/********************************************************/
#include "aggssrt.h"

void g7qknd0(void *akeys, int n,int size,int(*compare)(const void*,const void*))
{


 register char *keys=(char*) akeys;
 register char *x, *y;
 register int i,j,l,r,s;
 int lstack[STSZ];
 int rstack[STSZ];

 if (n<=1) return;
 x = (char *) malloc(size*sizeof(char));
 y = (char *) malloc(size*sizeof(char));
 s=0;
 lstack[0]=0;rstack[0]=n-1;
 do{
     l=lstack[s]; r=rstack[s]; --s;
     do{
         i=l;
         j=r;
         memcpy(x,&keys[((l+r)/2)*size],size);
         do{
             while (compare(&keys[i*size],x) < 0) ++i;
             while (compare(x,&keys[j*size]) < 0) --j;
             if (i <= j ) {
               memcpy(y,&keys[i*size],size);
               memcpy(&keys[i*size],&keys[j*size],size);
               memcpy(&keys[j*size],y,size);
               ++i; --j;
             }
         } while (i <= j);
         if (i < r) {
           ++s; lstack[s]=i; rstack[s]=r;
         } 
         r=j;
     } while (l<r);
 } while (s>= 0);
 free((void *)y); free((void *)x); 
}



void g7qknd1(void *akeys,int n,int size,int (*compare)(const void*,const void*))
{
 register int  M;
 register char *SRC, *DES;
 register char *keys=(char*) akeys;
 register char *x, *y;
 register int  i,j,l,r,s;
 int lstack[STSZ];
 int rstack[STSZ];

 if (n<=1) return;
 x = (char *) malloc(size*sizeof(char));
 y = (char *) malloc(size*sizeof(char));
 s=0;
 lstack[0]=0;rstack[0]=n-1;
 do{
     l=lstack[s]; r=rstack[s]; --s;
     do{
         i=l;
         j=r;
         MEMCPY(x,keys+((l+r)>>1)*size,size);
         do{
             while (compare(keys+i*size,x) < 0) ++i;
             while (compare(x,keys+j*size) < 0) --j;
             if (i <= j ) {
               MEMCPY(y,keys+i*size,size);
               MEMCPY(keys+i*size,keys+j*size,size);
               MEMCPY(keys+j*size,y,size);
               ++i;--j;
             }
        } while (i <= j);
        if (i < r) {
          if ((r-i) <SGQUI   )
            BGQUI (keys+i*size,(r-i+1),size,compare);
          else {
            ++s; lstack[s]=i; rstack[s]=r;
          }
        }
        r=j;
     } while (l<r);
 } while (s>=0);
 free((void *)y); free((void *)x);
}


void g7qknd2(void *akeys,int n,int size,int (*compare)(const void*,const void*))
{
 register int M;
 register char *SRC, *DES;
 register char *keys=(char*) akeys;
 register char *x, *y;
 register int  i,j,l,r,s,is,js;
 static int lstack[STSZ];
 static int rstack[STSZ];

 if (n<=1) return;
 x = (char *) malloc(size*sizeof(char));
 y = (char *) malloc(size*sizeof(char));
 s=0;
 lstack[0]=0;rstack[0]=n-1;
 do{
     l=lstack[s]; r=rstack[s]; --s;
     do{
         i=l; is = i*size;
         j=r; js = j*size;
         MEMCPY(x,keys+((l+r)>>1)*size,size);
         do{
             while (compare(keys+ is   ,x) < 0) {++i;is+=size;}
             while (compare(x,keys+  js  ) < 0) {--j;js-=size;}
             if (i <= j ) {
               MEMCPY(y,keys+is,size);
               MEMCPY(keys+is,keys+js,size);
               MEMCPY(keys+js,y,size);
               ++i; is+=size;--j;js -=size;
             }
         } while (i <= j);
         if (i < r) {
           if ((r-i) <SGQUI   )
             BGQUI (keys+is,(r-i+1),size,compare);
           else {
             ++s; lstack[s]=i; rstack[s]=r;
           }
         }
         r=j;
     } while (l<r);
 } while (s>=0);
 free((void *)y); free((void *)x);
}

void g7qknd3(void *akeys,int n,int size,int(*compare)(const void*,const void*))
{
 register int M;
 register char *SRC, *DES;
 register char *keys=(char *) akeys;
 char x[64],y[64];
 register int i,j,l,r,s,is,js;
 static int     lstack[STSZ];
 static int     rstack[STSZ];

 if (n<=1) return;
 s=0;
 lstack[0]=0;rstack[0]=n-1;
 do{
     l=lstack[s]; r=rstack[s]; --s;
     do{
         i=l; is = i*size;
         j=r; js = j*size;
         MEMCPY(x,keys+((l+r)>>1)*size,size);
         do{
             while (compare(keys+is,x) < 0) {++i;is+=size;}
             while (compare(x,keys+js) < 0) {--j;js-=size;}
             if (i <= j ) {
               MEMCPY(y,keys+is,size);
               MEMCPY(keys+is,keys+js,size);
               MEMCPY(keys+js,y,size);
               ++i; is +=size; --j; js -=size;
             }
          } while (i <= j);
          if (i < r) {
            if ((r-i) < SGQUI  )
              BGQUI (keys+is,(r-i+1),size,compare);
            else {
              ++s; lstack[s]=i; rstack[s]=r;
            }
          }
          r=j;
      } while (l<r);
 } while (s>= 0);
/*
 free((void *)x); free((void *)y);
*/
}




char *med3(char *a,char *b,char *c,int(*compare)(const void*,const void*));

void g7qknd4(void *akeys,int n,int size,int(*compare)(const void*,const void*))
{
 register int M;
 register char *SRC, *DES;
 register char *keys=(char*) akeys;
 register char *split,*pi,*pj,*t,*pm;
 register int  i,j,l,r,s,c;
 static   int  lstack[STSZ];
 static   int  rstack[STSZ];

 if (n<=1) return;
 split = (char *) malloc(size*sizeof(char));

 s=0;
 lstack[0]=0;rstack[0]=n-1;
 do{
      l=lstack[s]; r=rstack[s]; --s;
      do{
          i=l;
          j=r;
          pi= keys+i*size; pj= keys+j*size;
#if SPLITTER == MIDDLE_KEY
          if (n<12) {
            MEMCPY(split,(keys + ((l+r)>>1)*size),size);
          } 
          else {
            t=keys+((i+j)>>1)*size;
            pm = med3(pi,pj,t,compare);
            MEMCPY(split,pm,size);
          }
#else
          MEMCPY(split,(keys + ((l+r)>>1)*size),size);
#endif
          do{
              while (compare(pi,split) < 0) {++i;pi+=size;}
              while (compare(split,pj) < 0) {--j;pj-=size;}
              if (i <= j ) {
                M=size;
                do{
                    c= *pi; *pi++ = *pj; *pj++ = c;
                } while (--M);
                ++i; pj -=size; --j; pj -=size;
              }
          } while (i <= j);
          if (i < r) {
            if ((r-i) < SGQUI  )
              BGQUI (pi,(r-i+1),size,compare);
            else {
              ++s; lstack[s]=i; rstack[s]=r;
            }
          }
          r=j;
      } while (l<r);
 } while (s>=0);
 free((void*)split);
}

void g7qknd5(void *akeys,int n,int size,int(*compare)(const void*,const void*))
{ 
 register int M;
 register char *SRC, *DES;
 register char *keys=(char*) akeys;
 register char *split,*pi,*pj;
 register int  i,j,l,r,s,c;
 static   int  lstack[STSZ];
 static   int  rstack[STSZ];

 if (n<=1) return;
 split = (char *) malloc(size*sizeof(char));

 s=0;
 lstack[0]=0;rstack[0]=n-1;
 do{
     l=lstack[s]; r=rstack[s]; --s;
     do{
         i=l;
         j=r;
         pi= keys+i*size; pj= keys+j*size;
/*
         if (n<15) {
            MEMCPY(split,(keys + ((l+r)>>1)*size),size);
         }
         else {
           t=keys+((i+j)>>1)*size;
           pm = med50(pi,pj,t,compare);
           MEMCPY(split,pm,size);
         }
*/
         MEMCPY(split,(keys + ((l+r)>>1)*size),size);
         do{
             while (compare(pi,split) < 0) {++i;pi+=size;}
             while (compare(split,pj) < 0) {--j;pj-=size;}
             if (i <= j ) {
               M=size;
               do {
                    c= *pi; *pi++ = *pj; *pj++ = c;
               } while (--M);
               ++i; pj -=size; --j; pj -=size;
             }
         } while (i <= j);
         if (i < r) {
           if ((r-i) <SGQUI   )
             BGQUI (pi,(r-i+1),size,compare);
           else {
             ++s; lstack[s]=i; rstack[s]=r;
           }
         }
         r=j;
     } while (l<r);
 } while (s>=0);
 free((void *)split);
}



void g7qknd6(void *akeys,int n,int size,int(*compare)(const void*,const void*))
{
 register int M;
 register char *SRC, *DES;
 register char *keys=(char*) akeys;
 register char *split,*pi,*pj;
 register int  i,j,l,r,s,c;
 static   char X[64];
 static   int  lstack[STSZ];
 static   int  rstack[STSZ];

 if (n<=1) return;
 split=X;

 s=0;
 lstack[0]=0;rstack[0]=n-1;
 do{
     l=lstack[s]; r=rstack[s]; --s;
     do{
         i=l;
         j=r;
         pi= keys+i*size; pj= keys+j*size;
         MEMCPY(split,(keys + ((l+r)>>1)*size),size);
         do{
             while (compare(pi,split) < 0) {++i;pi+=size;}
             while (compare(split,pj) < 0) {--j;pj-=size;}
             if (i <= j ) {
               M=size;
               do {
                    c= *pi; *pi++ = *pj; *pj++ = c;
               } while (--M);
               ++i; pj -=size; --j; pj -=size;
             }
         } while (i <= j);
         if (i < r) {
           if ((r-i) < SGQUI  )
             BGQUI (pi,(r-i+1),size,compare);
           else {
             ++s; lstack[s]=i; rstack[s]=r;
           }
         }
         r=j;
     } while ( l < r);
 } while (s>= 0);
}




void g7qknd7(void *akeys,int n,int size,int(*compare)(const void*,const void*))
{ 
 register int M;
 register char *SRC, *DES;
 register char *keys=(char*) akeys;
 register char *split,*pi,*pj,*t,*pm;
 register int  i,j,l,r,s,c,I,J;
 static   int  lstack[STSZ];
 static   int  rstack[STSZ];

 if (n<=1) return;
 split = (char *) malloc(size*sizeof(char));

 s=0;
 lstack[0]=0;rstack[0]=n-1;
 do{
     l=lstack[s]; r=rstack[s]; --s;
     do{
         i=l;
         j=r;
         pi= keys+i*size; pj= keys+j*size;
#if SPLITTER == MIDDLE_KEY
         if (n< 8) {
            MEMCPY(split,(keys + ((l+r)>>1)*size),size);
         }
         else {
           t=keys+((i+j)>>1)*size;
           pm = med3(pi,pj,t,compare);
           MEMCPY(split,pm,size);
         }
#else
         MEMCPY(split,(keys + ((l+r)>>1)*size),size);
#endif
         do {
              while (compare(pi,split) < 0) {++i;pi+=size;}
              while (compare(split,pj) < 0) {--j;pj-=size;}
              if (i <= j ) {
                M=size;
                do {
                     c= *pi; *pi++ = *pj; *pj++ = c;
                } while (--M);
                ++i; pj -=size; --j; pj -=size;
              }
         } while (i <= j);
         if (i < r) {
           if ((r-i) < SGQUI  ) {
             if ((r-i) >0) {
               for(J=1;J<(r-i+1);J++){
                 MEMCPY(split,(pi+J*size),size);
                 I=J-1;pj=pi+I*size;
                 while ((I>=0) && (compare(pj,split)>0) ) {
                  MEMCPY((pj+size),(pj),size);
                  I--;pj-=size;
                 }
                 MEMCPY((pj+size),split,size);
               }
             }
           }
           else {
            s++; lstack[s]=i; rstack[s]=r;
           }
         }
         r=j;
     } while (l<r);
 } while (s>= 0);
 free((void *)split);
}
