/****Copyright (c) 1997-2004 All rights reserved
 ****A. V. Gerbessiotis and C. J. Siniolakis
 ****Permission to use, copy, modify, and distribute this software,
 ****and to incorporate it, in whole or in part, into 
 ****other software,is hereby granted without fee, provided that
 ****  (1) the above copyright notice and this permission 
 ****      notice appear in all copies of the source code, and 
 ****      the above copyright notice appear in clearly visible 
 ****      form on all supporting documentation and distribution 
 ****      media, and
 ****     (2) any redistribution of the software, in original
 ****         or modified form, be without fee and subject to
 ****         these same conditions.
 ****   No guarantee, whatsoever, is offered that the code works as
 ****   advertised or is absent of any, even damaging,
 ****   side-effects. Use this code at your own personal risk.
 ****/
#include "ssrt.h"
void bg20mrgit(void *asrc,int n,int sbytes,int (*compare)(const void*,const void*) )
{
 char *temp, *src;
 char *tmp, *s, *t;
 int  phase;
 register int idx;
 register int  i, j, l;
 int  q, r;

 if ((n<=1) ||(sbytes<=0)) return;
 src = (char *) asrc;

 temp= (char *) malloc(n*sbytes*sizeof(char));
#ifdef SANITY_CHECK
 check_if_null(temp,"gmrgst3","temp");
#endif
  for(idx=0;idx<n;idx+=MERGE16) {
      g11ins(&src[idx*sbytes],MIN(MERGE16,(n-idx)),sbytes,compare);
  }
  s=src;t=temp;
  for(phase =MERGE16;phase<n;phase=Times2(phase)) { 
      for (idx=0;idx<n;idx+=Times2(phase)) {
         q=MIN(idx+Times2(phase),n);r=MIN(idx+phase,n);
         i=r;j=idx;l=idx;  
         while ((i<q)&&(j<r)) {
           if (compare(&s[i*sbytes],&s[j*sbytes])<0) {
              memcpy(&t[l*sbytes],&s[i*sbytes],sbytes);
              ++i; ++l; 
           }
           else {
              memcpy(&t[l*sbytes],&s[j*sbytes],sbytes);
              ++j;++l;
           }
         }

         if (i<q) memcpy(&t[l*sbytes],&s[i*sbytes],(q-i)*sbytes);    
         if (j<r) memcpy(&t[l*sbytes],&s[j*sbytes],(r-j)*sbytes);
        }
      tmp=s;s=t;t=tmp;
    }

  if (s!=src) memcpy(src,s,n*sbytes); 

  free(temp);
}
