/****Copyright (c) 1997-2004 All rights reserved
 ****  C. J. Siniolakis
 ****Permission to use, copy, modify, and distribute this software,
 ****and to incorporate it, in whole or in part, into 
 ****other software,is hereby granted without fee, provided that
 ****  (1) the above copyright notice and this permission 
 ****      notice appear in all copies of the source code, and 
 ****      the above copyright notice appear in clearly visible 
 ****      form on all supporting documentation and distribution 
 ****      media, and
 ****     (2) any redistribution of the software, in original
 ****         or modified form, be without fee and subject to
 ****         these same conditions.
 ****   No guarantee, whatsoever, is offered that the code works as
 ****   advertised or is absent of any, even damaging,
 ****   side-effects. Use this code at your own personal risk.
 ****/
#include <stdio.h>
#include "ssrt.h"
#define  Parent(i)   ((i-1)>>1)
#define  Left(i)     ((i<<1)+1)
#define  Right(i)    ((i<<1)+2)


void bHeapify (char *heap,int nelems,int i,char *tmp,int schars,int (*compare)(const
void * , const void *))
{
  register int     l, r, t ;

  l = Left(i) ;
  r = Right(i) ;

  if ((l < nelems) && (compare(&heap[l*schars], &heap[i*schars]) > 0))
       t = l ;
  else t = i ;
  if ((r < nelems) && (compare(&heap[r*schars], &heap[t*schars]) > 0))
       t = r ;

  if (t != i)
    {
      memcpy(tmp, &heap[i*schars], schars) ;
      memcpy(&heap[i*schars], &heap[t*schars], schars) ;
      memcpy(&heap[t*schars], tmp, schars) ;
      bHeapify(heap, nelems, t, tmp, schars, compare) ;
    }

}

void bBuild_Heap (char *heap, int nelems, int schars, int (*compare)(const void *,const
void*))
{
  char *tmp ;
  register int    i ;

  if ((tmp = (char *)malloc(schars)) == NULL)
    {
      printf("heap_sort: out of memory.\n") ;
    }

  for (i = nelems - 1 ; i >= 0 ; --i)
    {
      bHeapify(heap, nelems, i, tmp, schars, compare) ;
    }

  free(tmp) ;
}

	

void bg34heapx(void *akeys, int n, int size, int (*compare) (const void*,const void*))
{
 char	*x,*keys;
 register int i ;

 keys=(char *)akeys;
 x=(char *) malloc(size*sizeof(char));
 bBuild_Heap(keys,n,size,compare);
 for (i = n-1;i>=1;--i){
      memcpy(x,keys,size);
      memcpy(keys,&keys[i*size],size);
      memcpy(&keys[i*size],x,size);
      bHeapify(keys,i,0,x,size,compare);
  }
  free(x);
}
