/****Copyright (c) 1997-2004 All rights reserved
 ****A. V. Gerbessiotis and C. J. Siniolakis
 ****Permission to use, copy, modify, and distribute this software,
 ****and to incorporate it, in whole or in part, into 
 ****other software,is hereby granted without fee, provided that
 ****  (1) the above copyright notice and this permission 
 ****      notice appear in all copies of the source code, and 
 ****      the above copyright notice appear in clearly visible 
 ****      form on all supporting documentation and distribution 
 ****      media, and
 ****     (2) any redistribution of the software, in original
 ****         or modified form, be without fee and subject to
 ****         these same conditions.
 ****   No guarantee, whatsoever, is offered that the code works as
 ****   advertised or is absent of any, even damaging,
 ****   side-effects. Use this code at your own personal risk.
 ****/
#include "ssrt.h"

void bg46qsrtl(void *asrc, int   n,int size,int (*compare)(const void*,const void*))
{
  char *mid,*tmp,*src;
  register int  l, r ;

  if (n <= 1) return ;
  l=0;r=n-1;
  src=(char *) asrc;
  mid = (char *) malloc(size*sizeof(char));
  tmp = (char *) malloc(size*sizeof(char));

  memcpy(mid,&src[((l+r)>>1)*size],size);

  while (l <= r) {
      while (compare(&src[l*size],mid)<0) ++l ;
      while (compare(mid,&src[r*size])<0) --r ;
      if (l <= r) {
	  memcpy(tmp,&src[l*size],size);
	  memcpy(&src[l*size],&src[r*size],size);
	  memcpy(&src[r*size],tmp,size);
          ++l ; --r ;
      }
  }
  
  if (r > 0) {
      if ((r + 1) < THRES16) BASES (src, r + 1,size,compare) ;
      else bg46qsrtl(src, r + 1,size,compare) ;
  }
  if (l < n) {
      if ((n - l) < THRES16) BASES (&src[l*size], n - l,size,compare) ;
      else bg46qsrtl(&src[l*size], n - l,size,compare) ;
  }
 free((void *)mid); free((void *)tmp);
}
           
void bg46qsrt(void *keys, int n, int size, int (*compare) (const void*,const void *))
{
  if (n <= 1) return ;
  bg46qsrtl(keys,n,size,compare);
}

