/****Copyright (c) 1997-2004 All rights reserved
 ****A. V. Gerbessiotis 
 ****Permission to use, copy, modify, and distribute this software,
 ****and to incorporate it, in whole or in part, into 
 ****other software,is hereby granted without fee, provided that
 ****  (1) the above copyright notice and this permission 
 ****      notice appear in all copies of the source code, and 
 ****      the above copyright notice appear in clearly visible 
 ****      form on all supporting documentation and distribution 
 ****      media, and
 ****     (2) any redistribution of the software, in original
 ****         or modified form, be without fee and subject to
 ****         these same conditions.
 ****   No guarantee, whatsoever, is offered that the code works as
 ****   advertised or is absent of any, even damaging,
 ****   side-effects. Use this code at your own personal risk.
 ****/
#include "ssrt.h"

void ag170my5  (void *akeys, int n, int size, int (*compare) (const void*,const void*),int l,int r)
{
 register char *split,*tmp,*keys,*pm;
 register int i,j,M;
 char *DES,*SRC;

 if (l>=r) return;
 keys = (char *) akeys;
 tmp  = (char *) malloc(size*sizeof(char));
 split= (char *) malloc(size*sizeof(char));
#ifdef SANITY_CHECK
  check_if_null(tmp  ,"g170my5","tmp ");
  check_if_null(split,"g170my5","split");
#endif
#if SPLITTER == MIDDLE_KEY
  pm = &keys[((l+r)>>1)*size];
#elif SPLITTER == FIRST_KEY
  pm = &keys[l*size];
#elif SPLITTER == RANDOM_KEY
  pm = &keys[(l+GRANDOM((r-l+1)))*size];
#endif
  MEMCPY(split,pm,size);
  MEMCPY(pm,keys+r*size,size);
  MEMCPY(keys+r*size,split,size);
  /* MEMCPY(split,&keys[r*size],size); */
 i=l; j=r-1;
 while (i<=j) {
   while ((i<=j) && (compare(&keys[i*size],split) <= 0))  i++;
   while ((j>=i) && (compare(&keys[j*size],split) >= 0))  j--;
   if (i<j)  {
     MEMCPY(tmp,&keys[i*size],size);
     MEMCPY(&keys[i*size],&keys[j*size],size);
     MEMCPY(&keys[j*size],tmp,size);
   }
 }

 MEMCPY(tmp,&keys[i*size],size);
 MEMCPY(&keys[i*size],&keys[r*size],size);
 MEMCPY(&keys[r*size],tmp,size);

   M=i;
   ag170my5(akeys,n,size,compare,l,i-1);
   ag170my5(akeys,n,size,compare,i+1,r);
}

void g170my5  (void *keys, int n, int size, int (*compare) (const void*,const void *))
{
  if (n <= 1) return ;
  ag170my5  (keys,n,size,compare,0,n-1);
}
