/****Copyright (c) 1997-2011 All rights reserved
 ****A. V. Gerbessiotis 
 ****Permission to use, copy, modify, and distribute this software,
 ****and to incorporate it, in whole or in part, into 
 ****other software,is hereby granted without fee, provided that
 ****  (1) the above copyright notice and this permission 
 ****      notice appear in all copies of the source code, and 
 ****      the above copyright notice appear in clearly visible 
 ****      form on all supporting documentation and distribution 
 ****      media, and
 ****     (2) any redistribution of the software, in original
 ****         or modified form, be without fee and subject to
 ****         these same conditions.
 ****   No guarantee, whatsoever, is offered that the code works as
 ****   advertised or is absent of any, even damaging,
 ****   side-effects. Use this code at your own personal risk.
 ****/
#include "ssrt.h"

void g24sel(void *akeys,int n,int size,int (*compare)(const void*,const void*))
{
 register int i,j,k,M;
 register char	*tmp, *keys,*p,*DES,*SRC;

 if (n<=1) return;
 keys = (char *)akeys;
 tmp = (char *) malloc(size*sizeof(char));
#ifdef SANITY_CHECK
  check_if_null(tmp,"g24sel","tmp");
#endif
 for(i=0;i<n-1;i++) {
   k=i; 
   MEMCPY(tmp,(keys+i*size),size);
   for(j=i+1;j<n;j++) {
     p=keys+j*size;
     if (compare(p,tmp) < 0) {
       k=j;
       MEMCPY(tmp,p,size);
     }
   }
   MEMCPY(&keys[k*size],&keys[i*size],size);
   MEMCPY(&keys[i*size],tmp,size);
 }
 free((void*)tmp);
}
