/****Copyright (c) 1997-2004 All rights reserved
 ****A. V. Gerbessiotis 
 ****Permission to use, copy, modify, and distribute this software,
 ****and to incorporate it, in whole or in part, into 
 ****other software,is hereby granted without fee, provided that
 ****  (1) the above copyright notice and this permission 
 ****      notice appear in all copies of the source code, and 
 ****      the above copyright notice appear in clearly visible 
 ****      form on all supporting documentation and distribution 
 ****      media, and
 ****     (2) any redistribution of the software, in original
 ****         or modified form, be without fee and subject to
 ****         these same conditions.
 ****   No guarantee, whatsoever, is offered that the code works as
 ****   advertised or is absent of any, even damaging,
 ****   side-effects. Use this code at your own personal risk.
 ****/
#include "ssrt.h"

void g266non2(void *akeys, int n, int size, int (*compare) (const void*,const void*))
{
 register int i,j,l,r,s,M,c,I,J;
 register char *keys;
 register char *SRC,*DES;
 register char *split,*pi,*pj,*pl,*pr;
#ifdef MEM_CHECK
 register char *tmp;
#endif
 static int	lstack[STACK_SIZE_QS];
 static int	rstack[STACK_SIZE_QS];

  if (n <= 1) return;
  keys  = (char *) akeys;
  split = (char *) malloc(size*sizeof(char));
#ifdef    MEM_CHECK
  tmp   = (char *) malloc(size*sizeof(char));
#endif
#ifdef SANITY_CHECK
/*
  split=Split;tmp=Tmp;
 */
  check_if_null(tmp,  "g266non2","tmp");
  check_if_null(split,"g266non2","split");
#endif
  s=0;
  lstack[0]=0;rstack[0]=n-1;

do {
    l=lstack[s]; r=rstack[s]; s--;
    do {
	i=l; 
	j=r; 
	MEMCPY(split,&keys[((l+r)>>1)*size],size);
        pi=&keys[i*size];
        pj=&keys[j*size];
	while(i<=j) {
          while (compare(pi,split) < 0) {i++;pi+=size;}
          while (compare(split,pj) < 0) {j--;pj-=size;}

	  if (i <= j ) {
/*
            MEMCPY(tmp,pi,size);
            MEMCPY(pi,pj,size);
            MEMCPY(pj,tmp,size);
*/
            M=size;
            do {
             c= *pi; *pi++ = *pj ; *pj++=c;
            } while (--M);
            i++; pj -=size;
            j--; pj -=size;
           }
	} 
		
     
#ifdef UNOPTIMIZED_BUT_WORKS
    if ((r-i+1) < (j-l+1)) {
	if (i < r)  {
	    s++; lstack[s]=i; rstack[s]=r;
        }
	    r=j;
    } 
    else {
        if (l < j)  {
	    s++; lstack[s]=l; rstack[s]=j;
        }
	    l=i;
    }
#endif
#ifdef OPTIMIZED
#endif
       if ((r-i+1) < (j-l+1)) {
	if (i < r) {
          if ((r-i+1) <THRES16 ) {
/*
	    BASES (pi,(r-i+1),size,compare);
*/
                             if ((r-i +1) >1) {
                  pl=pi;
                  for(J=1;J<(r-i +1);J++){
                    MEMCPY(split,(pl+J*size),size);
                    I=J-1;pr=pl+I*size;
                    while ((I>=0) && (compare(pr,split)>0) ) {
                     MEMCPY((pr+size),(pr),size);
                     I--;pr-=size;
                    }
                    MEMCPY((pr+size),split,size);
                  }
                 }

          }
          else {
	    s++; lstack[s]=i; rstack[s]=r;
          }
        }
	r=j;
       }
       else {
	if (l < j) {
          if ((j-l+1) <THRES16 ) {
/*
	    BASES (&keys[l*size],(j-l+1),size,compare);
*/
                             if ((j-l +1) >1) {
                  pl=&keys[l*size];
                  for(J=1;J<(j-l +1);J++){
                    MEMCPY(split,(pl+J*size),size);
                    I=J-1;pr=pl+I*size;
                    while ((I>=0) && (compare(pr,split)>0) ) {
                     MEMCPY((pr+size),(pr),size);
                     I--;pr-=size;
                    }
                    MEMCPY((pr+size),split,size);
                  }
                 }

          }
          else {
	    s++; lstack[s]=l; rstack[s]=j;
          }
        }
	l=i;
       }
      } while ( l < r);

   } while (s>= 0);
/*
 free((void *)split); free((void *)tmp);
*/
}
