/****Copyright (c) 1997-2004 All rights reserved
 ****A. V. Gerbessiotis 
 ****Permission to use, copy, modify, and distribute this software,
 ****and to incorporate it, in whole or in part, into 
 ****other software,is hereby granted without fee, provided that
 ****  (1) the above copyright notice and this permission 
 ****      notice appear in all copies of the source code, and 
 ****      the above copyright notice appear in clearly visible 
 ****      form on all supporting documentation and distribution 
 ****      media, and
 ****     (2) any redistribution of the software, in original
 ****         or modified form, be without fee and subject to
 ****         these same conditions.
 ****   No guarantee, whatsoever, is offered that the code works as
 ****   advertised or is absent of any, even damaging,
 ****   side-effects. Use this code at your own personal risk.
 ****/
#include "ssrt.h"
/* this is g52dbh.c g62dbh is more optimized*/

void amy2  (void *akeys, int n, int size, int (*compare) (const void*,const void*),int l,int r)
{
 char *split,*tmp,*keys;
 register int i,j,M;
 char *DES,*SRC;

 if (n<=1) return;
 keys = (char *) akeys;
 tmp  = (char *) malloc(size*sizeof(char));
 split= (char *) malloc(size*sizeof(char));
#ifdef SANITY_CHECK
  check_if_null(tmp,"amy2  ","tmp");
  check_if_null(split,"amy2  ","split");
#endif
 i=l;j=r;
#if SPLITTER == MIDDLE_KEY
 memcpy(split,&keys[((l+r)>>1)*size],size);
#elif SPLITTER == FIRST_KEY
 memcpy(split,&keys[l*size],size);
#elif SPLITTER == RANDOM_KEY
 memcpy(split,&keys[(l+GRANDOM((r-l+1)))*size],size);
#endif

 do {
   while (compare(&keys[i*size],split) < 0) i++;
   while (compare(split,&keys[j*size]) < 0) j--;
   if (i <= j ) {
     MEMCPY(tmp,&keys[i*size],size);
     MEMCPY(&keys[i*size],&keys[j*size],size);
     MEMCPY(&keys[j*size],tmp,size);
/*
     SWAPPY(&keys[i*size],&keys[j*size],tmp,size);
*/
     i++;j--;
   }
 } while (i <= j);
	
 if (l < j) {
   if ((j-l+1) < THRES16) {
     BASES  (keys+l*size,(j-l+1),size,compare);
   }
   else {
     amy2  (keys,n,size,compare,l,j);
   }
 }

  if (i < r) {
    if ((r-i+1) < THRES16) {
      BASES  (keys+i*size,(r-i+1),size,compare);
    }
  else {
      amy2  (keys,n,size,compare,i,r);
  }
 }
	
 free((void *)split); free((void *)tmp);
}

void my2  (void *keys, int n, int size, int (*compare) (const void*,const void *))
{
  if (n <= 1) return ;
#if SPLITTER == RANDOM_KEY
 GSRANDOM();
#endif
  amy2(keys,n,size,compare,0,n-1);
}
