/****Copyright (c) 1997-2004 All rights reserved
 ****A. V. Gerbessiotis 
 ****Permission to use, copy, modify, and distribute this software,
 ****and to incorporate it, in whole or in part, into 
 ****other software,is hereby granted without fee, provided that
 ****  (1) the above copyright notice and this permission 
 ****      notice appear in all copies of the source code, and 
 ****      the above copyright notice appear in clearly visible 
 ****      form on all supporting documentation and distribution 
 ****      media, and
 ****     (2) any redistribution of the software, in original
 ****         or modified form, be without fee and subject to
 ****         these same conditions.
 ****   No guarantee, whatsoever, is offered that the code works as
 ****   advertised or is absent of any, even damaging,
 ****   side-effects. Use this code at your own personal risk.
 ****/
#include "ssrt.h"
/* This is CAR Hoare as it appears on Cormen page 160*/

void amy3  (void *akeys, int n, int size, int (*compare) (const void*,const void*),int l,int r)
{
 char *split,*tmp,*keys;
 register int i,j,M;
 char *DES,*SRC;

 if (l>=r) return;

 keys = (char *) akeys;
 tmp  = (char *) malloc(size*sizeof(char));
 split= (char *) malloc(size*sizeof(char));

 memcpy(split,&keys[l*size],size);
 i=l-1; j=r+1;
 while (1) {
   do j--;
   while (compare(&keys[j*size],split) > 0) ;
   do i++;
   while (compare(&keys[i*size],split) < 0) ;
   if (i<j)  {
     MEMCPY(tmp,&keys[i*size],size);
     MEMCPY(&keys[i*size],&keys[j*size],size);
     MEMCPY(&keys[j*size],tmp,size);
   }
   else  break;

 }
   M=j;
   amy3(akeys,n,size,compare,l,M);
   amy3(akeys,n,size,compare,M+1,r);
}

void my3  (void *keys, int n, int size, int (*compare) (const void*,const void *))
{
  if (n <= 1) return ;
  amy3  (keys,n,size,compare,0,n-1);
}
