/****   Copyright (c) 2014 Alexandros V. Gerbessiotis
 ****
 ****   Permission to use, copy, modify, and distribute this software,
 ****   and to incorporate it, in whole or in part, into other software,
 ****   is hereby granted without fee, provided that
 ****     (1) the above copyright notice and this permission notice appear in
 ****         all copies of the source code, and the above copyright notice
 ****         appear in clearly visible form on all supporting documentation
 ****         and distribution media, and
 ****     (2) any redistribution of the software, in original
 ****         or modified form, be without fee and subject to
 ****         these same conditions.
 ****   No guarantee is offered that the code works as
 ****   advertised or is absent of any, even damaging,
 ****   side-effects; use this code on your own personal risk
 ****/

/* Cormen et al implementation with pointers */

#include        "issrt.h"
#define  VFF  256
#define  SIZE 1

void o32rdx4(unsigned int *inp,int n)
{
  register unsigned int *out, *ii, *end;
  register int i,j,k;
  unsigned int c[VFF];

  if (n <= 1) return;
  out= (unsigned int *) malloc(n*sizeof(unsigned int));


  /* ROUND-1 */
  end= inp+n*SIZE;
  memset(c,0,VFF*sizeof(int)); 
  for (ii=inp; ii< end; ii+=SIZE) {
     c[(*ii) & 0x000000FF]++; 
  } 
  for (j=1;j<VFF;j++) c[j] += c[j-1];

  for (ii=end-SIZE,i=n-1;i>=0;i--,ii-=SIZE) {
      k= --c[*ii & 0x000000FF]; 
      out[k]=*ii;
  }
  /* ROUND-2 */
  end= out+n*SIZE;
  memset(c,0,VFF*sizeof(int)); 
  for (ii=out; ii< end; ii+=SIZE) {
     c[(*ii >> 8) & 0x000000FF]++; 
  } 
  for (j=1;j<VFF;j++) c[j] += c[j-1];

  for (ii=end-SIZE,i=n-1;i>=0;i--,ii-=SIZE) {
      k= --c[(*ii>>8) & 0x000000FF]; 
      inp[k]=*ii;
  }
  /* ROUND-3 */
  end= inp+n*SIZE;
  memset(c,0,VFF*sizeof(int)); 
  for (ii=inp; ii< end; ii+=SIZE) {
     c[(*ii >>16) & 0x000000FF]++; 
  } 
  for (j=1;j<VFF;j++) c[j] += c[j-1];

  for (ii=end-SIZE,i=n-1;i>=0;i--,ii-=SIZE) {
      k= --c[(*ii>>16) & 0x000000FF]; 
      out[k]=*ii;
  }
  /* ROUND-3 */
  end= out+n*SIZE;
  memset(c,0,VFF*sizeof(int)); 
  for (ii=out; ii< end; ii+=SIZE) {
     c[(*ii >>24) ]++; 
  } 
  for (j=1;j<VFF;j++) c[j] += c[j-1];

  for (ii=end-SIZE,i=n-1;i>=0;i--,ii-=SIZE) {
      k= --c[(*ii>>24) ]; 
      inp[k]=*ii;
  }

  free((void *)out);
}
